﻿﻿Ajax.Request.prototype.setRequestHeaders = Ajax.Request.prototype.setRequestHeaders.wrap(
    function(original) {
        this.transport.setRequestHeader("If-Modified-Since", "Thu, 1 Jan 1970 00:00:00 GMT");
        original(); // then call the original version
    });

﻿Ajax.JSON = Class.create(Ajax.Request, {
    initialize: function($super, url, options) {
        options = options || { };
        options.contentType = 'application/json;charset=utf-8';
        options.postBody = Object.toJSON(options.object);
        $super(url, options);
    }
﻿});


//Register the exception handler.
//Currently being used for session time-out.
﻿Ajax.Responders.register({
    onException: function(transport, exception) {
        var strMsg = exception.message;
        checkForSecurityAndLogout(strMsg);
        if (strMsg.match('loginForm')) {
            //alert('The current session has timed-out');
            window.location.href = 'login.jsp?timeout=true';
        }
    }
﻿});

﻿function checkSession(url, specialModalClass) {
    new Ajax.Request(urlConfig.checkSession, {
        method: 'get',
        onComplete: function(transport) {
            if (transport != null && transport.responseText.match('loginForm')) {
                //alert('The current session has timed-out');
                window.location.href = 'login.jsp?timeout=true';
            } else {
                if (url != "" && specialModalClass != "") {
                    openModal(url, specialModalClass);
                }
            }
        }
    });
﻿}

﻿function checkSessionEx() {
    new Ajax.Request(urlConfig.checkSession, {
        method: 'get',
        onComplete: function(transport) {
            if (transport != null && transport.responseText.match('loginForm')) {
                //alert('The current session has timed-out');
                window.location.href = 'login.jsp';
            }

        }
    });
﻿}


﻿function openModalAndCheckSession(url, specialModalClass) {
    checkSession(url, specialModalClass);

﻿}


﻿function openModalAndCloseSectionMessage(url, specialModalClass, itemArgs) {
    if ($('section_2_0_messages')) {
        for (var i = 0; i < 100; i++) {
            if ($('section_2_0_messages').down('div.msgSuccess', i)) {
                $('section_2_0_messages').down('div.msgSuccess', i).blindUp();
            }
        }
    }
    openModalAndCheckSession(url, specialModalClass);
    if (itemArgs != null && itemArgs.length > 1) {
        var vCenterInfoArray = itemArgs.split('^');
        var vCenterInfo = new VCenterInfo();
        vCenterInfo.machineId = vCenterInfoArray[0];
        vCenterInfo.machineName = vCenterInfoArray[1];
        vCenterInfo.machineIp = vCenterInfoArray[2];
        vCenterInfo.userName = vCenterInfoArray[3];
        vCenterInfo.password = vCenterInfoArray[4];
        vCenterInfo.vPassword = vCenterInfoArray[4];
        VCenter.selectedVCenter = vCenterInfo;
    }
﻿}

﻿var SimpleForm = {
    contentBlockDivInnerHTML: null,
    contentBlockDiv4InnerHTML: null,
    contentBlockDiv5InnerHTML: null,
    contentBlockDiv30InnerHTML: null,
    contentBlockDiv31InnerHTML: null,
    contentBlockDiv9InnerHTML: null
﻿};

﻿function setSimpleFormContentBlock(contentBlockDivId) {
    if ($(contentBlockDivId)) {
        switch (contentBlockDivId) {
        case '1':
            SimpleForm.contentBlockDivInnerHTML = $(contentBlockDivId).innerHTML;
            break;
        case 'block_section_4_0_0_1':
            SimpleForm.contentBlockDiv4InnerHTML = $(contentBlockDivId).innerHTML;
            break;
        case 'block_section_5_0_0_1':
            SimpleForm.contentBlockDiv5InnerHTML = $(contentBlockDivId).innerHTML;
            break;
        case 'block_section_30_0_0_1':
            SimpleForm.contentBlockDiv30InnerHTML = $(contentBlockDivId).innerHTML;
            break;
        case 'block_section_31_0_0_1':
            SimpleForm.contentBlockDiv31InnerHTML = $(contentBlockDivId).innerHTML;
            break;
        case 'block_section_9_0_0_0':
            SimpleForm.contentBlockDiv9InnerHTML = $(contentBlockDivId).innerHTML;
            break;
        }
    }
﻿}

﻿function getSimpleFormContentBlock(contentBlockDivId) {
    if ($(contentBlockDivId)) {
        switch (contentBlockDivId) {
        case '1':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDivInnerHTML;
            break;
        case 'block_section_4_0_0_1':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv4InnerHTML;
            break;
        case 'block_section_5_0_0_1':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv5InnerHTML;
            break;
        case 'block_section_30_0_0_1':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv30InnerHTML;
            break;
        case 'block_section_31_0_0_1':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv31InnerHTML;
            break;
        case 'block_section_9_0_0_0':
            $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv9InnerHTML;
            break;
        }
    }
﻿}

﻿function applyEditModeForSimpleForm(sectionId, functionName) {
    if ($(sectionId)) {
        if ($(sectionId).down('form')) {
            var form = $(sectionId).down('form');
        } else if ($(sectionId).up('form')) {
            var form = $(sectionId).up('form');
        }

        if (form) {
            if (functionName != null) {
                eval(functionName(form));
            }
        }

        toggleSectionEditMode(sectionId);
    }
﻿}

﻿function editButtonClickForSimpleForm(sectionId, contentBlockDivId) {
    if ($(sectionId)) {
        if ($(sectionId).down('form')) {
            var form = $(sectionId).down('form');
        } else if ($(sectionId).up('form')) {
            var form = $(sectionId).up('form');
        }
    }
    if (form && !$(sectionId).down('div.sectionEditButton.disabled')) {
        if (form.down('span#vpassword')) {
            if (form.down('span#vpassword').up('tr')) {
                // Unhide the Verify Password table row.
                form.down('span#vpassword').up('tr').removeClassName('hidden');
            }
        }
        if (form.down('span#password')) {
            if (form.down('span#password').up('tr')) {
                // Unhide the Password table row.
                form.down('span#password').up('tr').removeClassName('hidden');
            }
        }

        if (form.down('span#vencpassword')) {
            if (form.down('span#vencpassword').up('tr')) {
                // Unhide the Verify Password table row.
                form.down('span#vencpassword').up('tr').removeClassName('hidden');
            }
        }
        if (form.down('span#encpassword')) {
            if (form.down('span#encpassword').up('tr')) {
                // Unhide the Password table row.
                form.down('span#encpassword').up('tr').removeClassName('hidden');
            }
        }


        setSimpleFormContentBlock(contentBlockDivId);
    }
    editButtonClick(sectionId);
﻿}

﻿function hidePasswordTR() {
    if ($('password')) {
        if ($('password').up('tr')) {
            $('password').up('tr').addClassName('hidden');
        }
    }
﻿}

﻿function hideVPasswordTR() {
    if ($('vpassword')) {
        if ($('vpassword').up('tr')) {
            $('vpassword').up('tr').addClassName('hidden');
        }
    }
﻿}

﻿function hideEncPasswordTR() {
    if ($('encpassword')) {
        if ($('encpassword').up('tr')) {
            $('encpassword').up('tr').addClassName('hidden');
        }
    }
﻿}

﻿function hideVEncPasswordTR() {
    if ($('vencpassword')) {
        if ($('vencpassword').up('tr')) {
            $('vencpassword').up('tr').addClassName('hidden');
        }
    }
﻿}

﻿function showEditPassMsg() {
    if ($('modifyPassword')) {
        if ($('modifyPassword').up('tr')) {
            $('modifyPassword').up('tr').removeClassName('hidden');
        }
    }
﻿}

﻿function hideEditPassMsg() {
    if ($('modifyPassword')) {
        if ($('modifyPassword').up('tr')) {
            $('modifyPassword').up('tr').addClassName('hidden');
        }
    }
﻿}

﻿function cancelButtonClickWithoutEditMode(contentBlockDivId, sectionMessagesId) {
    if (contentBlockDivId == 'block_section_9_0_0_0') {
        // Reset the admin password form fields to blank.
        if ($('current_password')) {
            $('current_password').value = '';
        }
        if ($('new_password')) {
            $('new_password').value = '';
        }
        if ($('verify_new_password')) {
            $('verify_new_password').value = '';
        }
    }

    getSimpleFormContentBlock(contentBlockDivId);

    // Hide any old Failure or Success message using a blind up effect.
    $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });
﻿}

﻿function disableEditButtonsAndShowStartMsg(sectionId) {
    var sectionMessagesId = sectionId + '_messages';

    // Disable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $(sectionId).select('.sectionEditButtons button').each(function(item) {
        item.disabled = true;
        item.removeClassName('stdButtonEmphasized1');
        item.addClassName('stdButtonDisabled');
    });

    // Hide any old Failure or Success message using a blind up effect.
    $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });

    // Display only one (generic) Starting message.
    if ($(sectionMessagesId).down('div#divMsgStarting', 0)) {
        $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.setStyle({ display: '' }); });
    } else {
        $(sectionMessagesId).insert({ bottom: '<div id="divMsgStarting" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.processing') + '</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate('generic.pleaseWait') + '.....</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'divMsgStarting\');"></div></div>' });
    }
﻿}

﻿function enableEditButtonsAndHideMsg(sectionId) {
    var sectionMessagesId = sectionId + '_messages';

    // Enable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $(sectionId).select('.sectionEditButtons button').each(function(item) {
        item.disabled = false;
        if (item.type && item.type == 'submit') {
            item.addClassName('stdButtonEmphasized1');
        }
        ;
        item.removeClassName('stdButtonDisabled');
    });
    // Hide any old Start, Failure, or Success message using a blind up effect.
    $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });
﻿}

﻿function hideMsgUsingBlindUp(sectionId) {
    // Hide any old Start, Failure, or Success message using a blind up effect.
    var sectionMessagesId = sectionId + '_messages';
    $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });
﻿}

//VCenters

﻿var VCenterInfo = Class.create({
    initialize: function() {
        this.machineId = 0;
        this.machineName = '';
        this.machineIp = '';
        this.userName = '';
        this.password = '';
        this.vPassword = '';
    }
﻿});


﻿function registerVCenter() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    // Instantiate a vCenterInfo object and set property values.
    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = 0;
    vCenterInfo.machineName = $('machinename').value == Translator.translate('generic.notConfigured') ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == Translator.translate('generic.notConfigured') ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == Translator.translate('generic.notConfigured') ? '' : $('username').value;
    vCenterInfo.password = $('password').value == Translator.translate('generic.notConfigured') ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == Translator.translate('generic.notConfigured') ? '' : $('vpassword').value;

    // Post the object in JSON format.
    new Ajax.Request(urlConfig.registerVCenter, {
        parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { registerVCenterJSONResponse(transport.responseText); },
        onFailure: function(transport) { registerVCenterJSONResponse(transport.responseText); }
    });
﻿}


﻿function registerVCenterJSONResponse(vCenterResponse) {


    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }

        onVCenterPageLoad();
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}


﻿function modifyVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == Translator.translate('generic.notConfigured') ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == Translator.translate('generic.notConfigured') ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == Translator.translate('generic.notConfigured') ? '' : $('username').value;
    vCenterInfo.password = $('password').value == Translator.translate('generic.notConfigured') ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == Translator.translate('generic.notConfigured') ? '' : $('vpassword').value;
    new Ajax.Request(urlConfig.modifyVCenterCredentials, {
        parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_0'); },
        onFailure: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_0'); }
    });
﻿}


﻿function updateVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_3');

    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineName = $('machinename').value == Translator.translate('generic.notConfigured') ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == Translator.translate('generic.notConfigured') ? '' : $('machineip').value;

    new Ajax.Request(urlConfig.updateVCenterCertificate, {
        parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_3'); },
        onFailure: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_3'); }
    });
﻿}


﻿function testVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_2');
    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == Translator.translate('generic.notConfigured') ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == Translator.translate('generic.notConfigured') ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == Translator.translate('generic.notConfigured') ? '' : $('username').value;
    vCenterInfo.password = $('password').value == Translator.translate('generic.notConfigured') ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == Translator.translate('generic.notConfigured') ? '' : $('vpassword').value;

    new Ajax.Request(urlConfig.test, {
        parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_2'); },
        onFailure: function(transport) { modifyVCenterJSONResponse(transport.responseText, 'section_modalContent_2'); }
    });
﻿}


﻿function modifyVCenterJSONResponse(vCenterResponse, sectionId) {
    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }

        new Ajax.Request(urlConfig.getVCenters, {
            method: 'get',
            onComplete: function(transport) {
                displayVCenters(transport);
            }
        });
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg(sectionId);
        sectionMessagesId = sectionId + '_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}


﻿function unregisterVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == Translator.translate('generic.notConfigured') ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == Translator.translate('generic.notConfigured') ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == Translator.translate('generic.notConfigured') ? '' : $('username').value;
    vCenterInfo.password = $('password').value == Translator.translate('generic.notConfigured') ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == Translator.translate('generic.notConfigured') ? '' : $('vpassword').value;
    new Ajax.Request(urlConfig.unregisterVCenter, {
        parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { unregisterVCenterJSONResponse(transport.responseText); },
        onFailure: function(transport) { unregisterVCenterJSONResponse(transport.responseText); }
    });
﻿}


﻿function unregisterVCenterJSONResponse(vCenterResponse) {
    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onVCenterPageLoad();
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}


﻿function displayVCenters(transport) {
    var truncateLength = 30;
    var data;
    try {
        data = transport.responseText.evalJSON(true);
    } catch(e) {
        data = null;
    }

    var vCenterItems = '';
    if (data != null) {
        var strRowStyle = 'oddRow';
        var vCenters = data.VCenters;
        var serverTemplate = new Template('<td><span title="#{machineIp}">#{shortMachineIp}</span></td><td><span title="#{machineName}">#{shortMachineName}</span></td><td><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewModifyModal, \'halfWidth\', \'#{machineId}^#{empty}^#{machineIp}^#{userName}^#{password}\');">' + Translator.translate('generic.modify') + '</a></td><td><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewUpdateCredentialsModal, \'halfWidth\', \'#{machineId}^#{empty}^#{machineIp}^#{userName}^#{password}\');">' + Translator.translate('generic.update') + '</a></td><td style="white-space:nowrap;"><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewUnregisterModal, \'halfWidth\', \'#{machineId}^#{empty}^#{machineIp}^#{userName}^#{password}\');">' + Translator.translate('generic.unregister') + '</a></td><td class="lastCol"><div></div></td></tr>');
        if (vCenters.length > 0) {
            for (var i = 0; i <= vCenters.length - 1; i++) {
                vCenters[i].shortMachineName = vCenters[i].machineName == "" ? '<i>' + Translator.translate("generic.none") + '</i>' : vCenters[i].machineName.truncate(truncateLength, '...');
                vCenters[i].shortMachineIp = vCenters[i].machineIp.truncate(truncateLength, '...');
                vCenters[i].empty = "";
                vCenterItems += '<tr class="' + strRowStyle + '" style="display: table-row;">' + serverTemplate.evaluate(vCenters[i]);
                if (strRowStyle == 'oddRow') {
                    strRowStyle = 'evenRow';
                } else {
                    strRowStyle = 'oddRow';
                }
            }
        } else {
            // Display 'None'.
            vCenterItems += '<tr class="oddRow" style="display: table-row;"><td colspan="5" style="text-align:center;">' + Translator.translate('vcenterRegistration.noVcentersRegistered') + '</td></tr>';
        }
        vCenterItems += '<tr><td class="tableBottom" colspan="5"></td></tr>';
        $('section_2_0_0_table').down('tbody').replace(vCenterItems);
    } else {
        // Display 'None'.
        vCenterItems += '<tr class="oddRow" style="display: table-row;"><td colspan="5" style="text-align:center;">' + Translator.translate('vcenterRegistration.noVcentersRegistered') + '</td></tr>';
        +'<tr><td class="tableBottom" colspan="5"></td></tr>';
        $('section_2_0_0_table').down('tbody').replace(vCenterItems);
    }
    //Draw borders around tables, etc.
    postPageLoadUpdate();
﻿}

﻿var VCenter = {
    selectedVCenter: null
﻿};


//Appliance Management - Appliance Settings

﻿var VirtualApplianceActionInfo = Class.create({
    initialize: function() {
        this.restart = false;
        this.reset = false;
        this.secretKey = '';
    }
﻿});

﻿function restartVirtualAppliance() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var virtualApplianceActionInfo = new VirtualApplianceActionInfo();
    virtualApplianceActionInfo.restart = true;
    virtualApplianceActionInfo.secretKey = getSecretKey();
    new Ajax.Request(urlConfig.restartSpectre, {
        parameters: virtualApplianceActionInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setVirtualApplianceJSONResponse(transport.responseText); },
        onFailure: function(transport) { setVirtualApplianceJSONResponse(transport.responseText); }
    });
﻿}

﻿function resetVirtualAppliance() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var virtualApplianceActionInfo = new VirtualApplianceActionInfo();
    virtualApplianceActionInfo.reset = true;

    new Ajax.JSON(urlConfig.reset, {
        object: virtualApplianceActionInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setVirtualApplianceJSONResponse(transport.responseText); },
        onFailure: function(transport) { setVirtualApplianceJSONResponse(transport.responseText); }
    });
﻿}

﻿function setVirtualApplianceJSONResponse(virtualApplianceActionResponse) {
    var JobErrorResponse = virtualApplianceActionResponse.evalJSON(true).VirtualApplianceActionResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        //Logout the user
        window.location.href = "j_spring_security_logout";

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}

﻿function openVirtualApplianceActionModalAndCloseSectionMessage(url, specialModalClass) {
    $('section_2_0_messages').select('div.msgSuccess').each(function(item) { item.blindUp(); });
    openModalAndCheckSession(url, specialModalClass);
﻿}

﻿function openUploadCertificateModel() {
    openVirtualApplianceActionModalAndCloseSectionMessage(urlConfig.viewUploadCertificate, 'halfWidth');
﻿}

//Appliance Management - Proxy Settings

﻿function displayProxy(transport) {
    $('proxyTesting').hide();
    var data = null;
    if (transport.responseText.length > 0) {
        data = transport.responseText.evalJSON(true);
    } else {
        data = { ProxyInfo: null };
    }
    if (data.ProxyInfo) {
        var proxy = data.ProxyInfo;
        renderProxy(proxy);
    } else {
        var proxy = { enabled: false, proxyServer: "", port: "", userName: "" };
        renderProxy(proxy);
    }
﻿}

﻿function renderProxy(proxy) {
    var enabled = proxy.enabled == true ? Translator.translate('generic.enabled') : Translator.translate('generic.disabled');
    $('enable_proxy').innerHTML = enabled;
    $('proxy_server').innerHTML = proxy.proxyServer.length > 58 ? proxy.proxyServer.substring(0, 54) + '...' : proxy.proxyServer;
    if (proxy.proxyServer.length > 58)
        $('proxy_server').setAttribute('title', proxy.proxyServer);
    else
        $('proxy_server').setAttribute('title', '');
    
    $('port').innerHTML = proxy.port;

    if (proxy.userName.length > 0) {
        $('useCreds').innerHTML = Translator.translate('generic.yes');
        $('username').innerHTML = proxy.userName.length > 58 ? proxy.userName.substring(0, 54) + '...' : proxy.userName;
        
        if (proxy.userName.length > 58)
            $('username').setAttribute('title', proxy.userName);
        else $('username').setAttribute('title', '');

        $('password').innerHTML = '**********';
    } else {
        $('useCreds').innerHTML = Translator.translate('generic.no');
        $('username').innerHTML = Translator.translate('generic.notUsed');
        $('password').innerHTML = Translator.translate('generic.notUsed');
    }
    if (enabled == Translator.translate('generic.enabled')) {
        $('proxyTesting').show();
    } else {
        $('proxyTesting').hide();
    }
    $('val_proxytest_icon').removeClassName('val-waiting');
    $('val_proxytest_icon').removeClassName('val-fail');
    $('val_proxytest_icon').removeClassName('val-success');
    $('val_proxytest_msg').innerHTML = '';
﻿}

﻿var ProxyInfo = Class.create({
    initialize: function() {
        this.enabled = false;
        this.proxyServer = '';
        this.port = 0;
        this.userName = '';
        this.password = '';
        this.vPassword = '';

    }
﻿});

﻿function addNtpEvents() {
    
    var useNtpRdBtn = $$('input#enabled');

    try {
        useNtpRdBtn[0].observe('click', checkNtp);
        useNtpRdBtn[1].observe('click', checkNtp);
    } catch(e) {

    }

    checkNtp();
﻿}

﻿﻿function checkNtp() {

    var ntpRdBtn = $$('input#enabled');

    try {
        var ntpSetting = ntpRdBtn[0].checked ? true : false;


        if (!ntpSetting) {
            $('ntpPreferred').disable();
            $('ntpSecondary').disable();
            
        } else {
            $('ntpPreferred').enable();
            $('ntpSecondary').enable();


        }
    }
    catch(e) {
        
    }
﻿}

function addAutoBackupScheduleEvents() {
    var autoBackupRdBtn = $$('input#enabled_state');

    try {
        autoBackupRdBtn[0].observe('click', checkAuto);
        autoBackupRdBtn[1].observe('click', checkAuto);
    } catch(e) {

    }



    checkAuto();
﻿}
function addProxyEvents() {
    var useHttpProxySettingsCheckbox = $$('input#enable_proxy');

    try {
        useHttpProxySettingsCheckbox[0].observe('click', checkProxy);
        useHttpProxySettingsCheckbox[1].observe('click', checkProxy);
    } catch(e) {

    }

    var useProxyCredentialsCheckbox = $$('input#useCreds');
    try {
        useProxyCredentialsCheckbox[0].observe('click', checkProxy);
        useProxyCredentialsCheckbox[1].observe('click', checkProxy);
    } catch(e) {

    }

    checkProxy();
﻿}

﻿function checkAuto() {


    var autoBackupRdBtn = $$('input#enabled_state');
﻿

    try {
        var autoBackup = autoBackupRdBtn[0].checked ? true : false;
        var days = $$('input#days');        

        if (!autoBackup) {

        days[0].disable();
        days[1].disable();
        days[2].disable();
        days[3].disable();
        days[4].disable();
        days[5].disable();
        days[6].disable();
            
            $('timeOfBackup').disable();

        } else {
            days[0].enable();
        days[1].enable();
        days[2].enable();
        days[3].enable();
        days[4].enable();
        days[5].enable();
        days[6].enable();
            $('timeOfBackup').enable();

        }
    }
    catch(e) {
        
    }
﻿}
﻿function checkProxy() {
    $('proxyTesting').hide();

    var useHttpProxySettingsCheckbox = $$('input#enable_proxy');
    var useProxyCredentialsCheckbox = $$('input#useCreds');

    try {
        var useProxy = useHttpProxySettingsCheckbox[0].checked ? true : false;
        var useCreds = useProxyCredentialsCheckbox[0].checked ? true : false;

        if (!useProxy) {
            $('proxy_server').disable();
            $('port').disable();
            
            useProxyCredentialsCheckbox[0].checked=false;
            useProxyCredentialsCheckbox[1].checked=false;
            $('username').disable();
            $('password').disable();
        } else {
            $('proxy_server').enable();
            $('port').enable();
            
            if (!useCreds) {
                $('username').disable();
                $('password').disable();
                useProxyCredentialsCheckbox[1].checked=true;
            } else {
                $('username').enable();
                $('password').enable();
            }
        }
    }
    catch(e) {
        
    }
﻿}

﻿function testProxy() {
    $('val_proxytest_icon').addClassName('val-waiting');
    $('val_proxytest_msg').innerHTML = Translator.translate('applianceManagement.testingProxySettings') + '...';
    disableButton('btnTestProxy');
    new Ajax.Request(urlConfig.proxyTest, {
        method: 'get',
        onSuccess: function(transport) { proxyTestResult(transport.responseText); },
        onFailure: function(transport) { proxyTestResult(transport.responseText); }
    });
﻿}

﻿function proxyTestResult(result) {
    var JobErrorResponse = result.evalJSON(true).ProxyTestResponse;
    if (JobErrorResponse.responseCode == 0) {
        $('val_proxytest_icon').removeClassName('val-fail');
        $('val_proxytest_icon').addClassName('val-success');
        $('val_proxytest_msg').innerHTML = JobErrorResponse.errorMessage;
        enableButton('btnTestProxy');
    } else {
        $('val_proxytest_icon').removeClassName('val-success');
        $('val_proxytest_icon').addClassName('val-fail');
        $('val_proxytest_msg').innerHTML = JobErrorResponse.errorMessage;
        enableButton('btnTestProxy');
    }
﻿}

﻿function setProxy(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    //disableEditButtonsAndShowStartMsg('section_4_0');
    var enable_proxy_list = form.getInputs('radio', 'enable_proxy');
    var useCreds_list = form.getInputs('radio', 'useCreds');
    enable_proxy_list.each(function(radio) {
        radio.stopObserving('click');
    });
    useCreds_list.each(function(radio) {
        radio.stopObserving('click');
    });

    var proxyInfo = new ProxyInfo();
    proxyInfo.enabled = form.getInputs('radio', 'enable_proxy').size() != 0 ? (form.getInputs('radio', 'enable_proxy').find(function(radio) { return radio.checked; }).value == Translator.translate('generic.enabled') ? true : false) : false;
    
    if(proxyInfo.enabled == true)
    {
	    proxyInfo.proxyServer = $('proxy_server').value;
	    proxyInfo.port = Number($('port').value);
    } 
    else
    {
    	proxyInfo.proxyServer = '';
	    proxyInfo.port = 0;
    }
    // if proxy port is not a valid number format,set it to an invalid number (i.e. zero) so that JSON request gets sent
    if (isNaN(proxyInfo.port) || proxyInfo.port < 0) {
        proxyInfo.port = 0;
    }

	if (proxyInfo.enabled == true)
		proxyInfo.useCreds = form.getInputs('radio', 'useCreds').size() != 0 ? (form.getInputs('radio', 'useCreds').find(function(radio) { return radio.checked; }).value == Translator.translate('generic.yes') ? true : false) : false;
	else	
		proxyInfo.useCreds = false;

    if (proxyInfo.useCreds) {
        proxyInfo.userName = $('username').value;
        proxyInfo.password = $('password').value;
        proxyInfo.vPassword = $('password').value;
    } else {
        proxyInfo.userName = "";
        proxyInfo.password = "";
        proxyInfo.vPassword = "";
    }

    new Ajax.Request(urlConfig.setProxy, {
        parameters: proxyInfo,
        method: 'post',
        onSuccess: function(transport) { setProxyJSONResponse(transport.responseText); },
        onFailure: function(transport) { setProxyJSONResponse(transport.responseText); }
    });
﻿}

﻿function setProxyJSONResponse(proxyResponse) {
    var JobErrorResponse = proxyResponse.evalJSON(true).ProxyResponse;
    var sectionId = 'section_6_0';
    var contentBlockDivId = 'block_section_6_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            //hideMsgUsingBlindUp(sectionMessagesId);
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            cancelEditMode('section_6_0');
            resetProxyPassword();
        } else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            //enableEditButtonsAndHideMsg(sectionMessagesId');
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            clearProxyPassword();
            getSimpleFormContentBlock(contentBlockDivId);
            addProxyEvents();
        }
    }
﻿}

// Backup and Restore - Backup Now - section_30_0

﻿var BackupNowInfo = Class.create({
    initialize: function() {
        this.backup = false;
    }
﻿});

﻿function backupNow() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var backupInfo = new BackupShareInfo();
    backupInfo.share = $('backup_file_path').value;
    backupInfo.user = $('backup_username').value;
    backupInfo.password = $('backup_password').value;
    backupInfo.encryptionPassword = $('backup_encpassword').value;
    backupInfo.domain = $('backup_domain').value;

    new Ajax.Request(urlConfig.backupNow, {
        parameters: backupInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setBackupNowJSONResponse(transport.responseText); },
        onFailure: function(transport) { setBackupNowJSONResponse(transport.responseText); }
    });
﻿}

﻿function setBackupNowJSONResponse(backupNowResponse) {
    var JobErrorResponse = backupNowResponse.evalJSON(true).BackupNowResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_30_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onLoadBackupPage();
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onLoadBackupPage();
    }
﻿}

﻿function openBackupNowModalAndCloseSectionMessage(url, specialModalClass) {
    // Hide any old Success message using a blind up effect.
    $('section_30_0_messages').select('div.msgSuccess').each(function(item) { item.blindUp(); });

    openModalAndCheckSession(url, specialModalClass);
﻿}

﻿var RestoreInfo = Class.create({
    initialize: function() {
        this.filePath = '';
        this.userName = '';
        this.password = '';
        this.domain = '';
    }
﻿});

// Backup and Restore - Restore Now - _30_0_

﻿function restore() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    var restoreInfo = new BackupShareInfo();
    restoreInfo.share = $('restore_file_path').value;
    restoreInfo.user = $('restore_username').value;
    restoreInfo.password = $('restore_password').value;
    restoreInfo.encryptionPassword = $('restore_encpassword').value;
    restoreInfo.domain = $('restore_domain').value;

    new Ajax.Request(urlConfig.restore, {
        parameters: restoreInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setRestoreJSONResponse(transport.responseText); },
        onFailure: function(transport) { setRestoreJSONResponse(transport.responseText); }
    });
﻿}

﻿function setRestoreJSONResponse(restoreResponse) {
    var JobErrorResponse = restoreResponse.evalJSON(true).RestoreResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;
    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_30_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    } else {
        sectionMessagesId = 'section_modalContent_0_messages';
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}

//Backup and Restore - Backup Share (Domain, UserName, and Password) Data - _30_0_

﻿function displayBackupShare(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.BackupShareInfo) {
        var backupShareInfo = data.BackupShareInfo;
        $('share').innerHTML = backupShareInfo.share.length == 0 ? Translator.translate('generic.notConfigured') : backupShareInfo.share;
        $('domain').innerHTML = backupShareInfo.domain.length == 0 ? Translator.translate('generic.notConfigured') : backupShareInfo.domain;
        $('username').innerHTML = backupShareInfo.user.length == 0 ? Translator.translate('generic.notConfigured') : backupShareInfo.user;
        $('password').innerHTML = backupShareInfo.password.length == 0 ? '' : backupShareInfo.password;
        $('vpassword').innerHTML = backupShareInfo.vPassword.length == 0 ? '' : backupShareInfo.vPassword;
    }
﻿}

﻿var BackupShareInfo = Class.create({
    initialize: function() {
        this.share = '';
        this.domain = '';
        this.user = '';
        this.password = '';
        this.vPassword = '';
        this.encryptionPassword = '';
    }
﻿});

﻿function openRestoreModalAndCloseSectionMessage(url, specialModalClass) {
    // Hide any old Success message using a blind up effect.
    $('section_30_0_messages').select('div.msgSuccess').each(function(item) { item.blindUp(); });

    openModalAndCheckSession(url, specialModalClass);
﻿}

﻿function setBackupShare(form) {
    var backupShareInfo = new BackupShareInfo();
    backupShareInfo.share = $('share').value;
    if ($('domain').value != Translator.translate('generic.notConfigured')) {
        backupShareInfo.domain = $('domain').value;
    }

    backupShareInfo.user = $('username').value;
    backupShareInfo.password = $('password').value;
    backupShareInfo.vPassword = $('vpassword').value;

    new Ajax.Request(urlConfig.setBackupShare, {
        parameters: backupShareInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setBackupShareJSONResponse(transport.responseText); },
        onFailure: function(transport) { setBackupShareJSONResponse(transport.responseText); }
    });
﻿}

﻿function setBackupShareJSONResponse(backupShareResponse) {
    var JobErrorResponse = backupShareResponse.evalJSON(true).BackupShareResponse;
    var sectionId = 'section_30_0';
    var contentBlockDivId = 'block_section_30_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.

            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.success') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Hide (display: none) the Password table row.
            if ($('password')) {
                if ($('password').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('password').up('tr').addClassName('hidden');
                }
                $('password').innerHTML = '';
            }

            // Hide (display: none) the Verify Password table row.
            if ($('vpassword')) {
                if ($('vpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('vpassword').up('tr').addClassName('hidden');
                }
                $('vpassword').innerHTML = '';
            }
        } else {
            // Hide any old Start or Failure message using a blind up effect.
            $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.blindUp(); });
            $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate('generic.failed') + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);

            hidePasswordTR();
            hideVPasswordTR();

        }


    }
﻿}

// Backup and Restore - Backup Schedule - _31_0_

﻿function displayBackupSchedule(transport) {
    var data = transport.responseText.evalJSON(true);
    var localTime = '';
    if (data.BackupScheduleInfo) {
        var backupSchedule = data.BackupScheduleInfo;
        $('enabled_state').innerHTML = backupSchedule.enabled == true ? Translator.translate('generic.enabled') : Translator.translate('generic.disabled');

        var days = '';
        days = backupSchedule.sunday == true ? Translator.translate('generic.sundayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.monday == true ? Translator.translate('generic.mondayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.tuesday == true ? Translator.translate('generic.tuesdayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.wednesday == true ? Translator.translate('generic.wednesdayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.thursday == true ? Translator.translate('generic.thursdayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.friday == true ? Translator.translate('generic.fridayAbbrev') + ',&nbsp;' : '';
        days += backupSchedule.saturday == true ? Translator.translate('generic.saturdayAbbrev') + ',&nbsp;' : '';

        if (days.length > 7) {
            // Remove the trailing comma and escaped non-breaking space character sequence.
            days = days.substring(0, days.length - 7);
        }
        if (days.length == 0) {
            days = Translator.translate('generic.notConfigured');
        }
        $('days').innerHTML = days;
        if (backupSchedule.timeOfBackup.length > 0) {
            localTime = getLocalDateTime(backupSchedule.timeOfBackup);
            if (localTime != 'NaN') {
                localTime = getTimePart(localTime.toTimeString());
                $('timeOfBackup').innerHTML = localTime;
            } else {
                $('timeOfBackup').innerHTML = Translator.translate('generic.notConfigured');
            }
        } else {
            $('timeOfBackup').innerHTML = Translator.translate('generic.notConfigured');
        }

        localTime = getLocalDateTime(backupSchedule.nextBackup);
        if (localTime != 'NaN') {
            $('nextBackup').innerHTML = localTime.toLocaleDateString() + " " + getTimePart(localTime.toTimeString()) + " " + buildTimeZoneDesignation();
        } else {
            $('nextBackup').innerHTML = backupSchedule.nextBackup;
        }
        localTime = getLocalDateTime(backupSchedule.lastBackupDate);
        if (localTime != 'NaN') {
            $('lastBackupDate').innerHTML = localTime.toLocaleDateString() + " " + getTimePart(localTime.toTimeString()) + " " + buildTimeZoneDesignation();
        } else {
            $('lastBackupDate').innerHTML = backupSchedule.lastBackupDate;
        }

        $('lastBackupStatus').innerHTML = backupSchedule.lastBackupStatus;

    }

﻿}

﻿var BackupScheduleInfo = Class.create({
    initialize: function() {
        this.enabled = false;
        this.sunday = false;
        this.monday = false;
        this.tuesday = false;
        this.wednesday = false;
        this.thursday = false;
        this.friday = false;
        this.saturday = false;
        this.timeOfBackup = '';
        this.lastBackupDate = Translator.translate('generic.notDetermined');
        this.lastBackupStatus = Translator.translate('generic.notDetermined');
        this.nextBackup = Translator.translate('generic.notDetermined');
        this.serverTimeZone = '';
        this.serverTime = '';
        this.secretKey = '';
        this.timezoneOffset = 0;
    }
﻿});

﻿function setBackupSchedule(form) {
    var backupScheduleInfo = new BackupScheduleInfo();
    backupScheduleInfo.enabled = Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').size() != 0 ? (Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').find(function(radio) { return radio.checked; }) != null ? (Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').find(function(radio) { return radio.checked; }).value == Translator.translate('generic.enabled') ? true : false) : false) : false;

    var days = Form.getInputs('frmBackupSchedule', 'checkbox', 'days[]');

    // checkbox tests for validation
    var atleastOneChecked = false;
    days.each(function(el) {
        if (el.checked) {
            atleastOneChecked = true;
        }
    }); // timeOfBackup form field validation
    var timeOfBackup = $('timeOfBackup').value;
    var timeOfBackupIsValid = true;
    var finalDate = '';

    if (timeOfBackup == '' || timeOfBackup == "HH:mm" || timeOfBackup == Translator.translate('generic.notConfigured')) {
        timeOfBackupIsValid = false;
    } else {
        timeOfBackupIsValid = false;
        var date = new Date();
        var time = $('timeOfBackup').value;
        time = time.split(":", 2);
        if (time.length == 2) {
            if (time[0].length == 2 && time[1].length == 2) {
                var hours = parseInt(time[0]);
                var minutes = parseInt(time[1]);
                if ((hours >= 0 && hours <= 23) && (minutes >= 0 && minutes <= 59)) {
                	finalDate = new Date(date.getFullYear(), date.getMonth() , date.getDate(), time[0], time[1], 0);
                if (finalDate.toString() != 'NaN') {
                	finalDate = finalDate.getUTCMonth() + "/" + finalDate.getUTCDate() + "/" + finalDate.getUTCFullYear() + "/" + finalDate.getUTCHours() + "/" + finalDate.getUTCMinutes();
                	timeOfBackupIsValid = true;
                }

                	
//                    if(date.getMonth() == 11)
//                        finalDate = new Date(date.getFullYear(), date.getMonth() , date.getDate(), time[0], time[1], 0); 
//                    else 
//                        finalDate = new Date(date.getFullYear(), date.getMonth() + 1, date.getDate(), time[0], time[1], 0);
//                    if (finalDate.toString() != 'NaN') {
//                        finalDate = finalDate.getUTCMonth() + "/" + finalDate.getUTCDate() + "/" + finalDate.getUTCFullYear() + "/" + finalDate.getUTCHours() + "/" + finalDate.getUTCMinutes();
//                        timeOfBackupIsValid = true;
//                    }
                }

            }

        }
    }
    if(backupScheduleInfo.enabled==false){        
        backupScheduleInfo.secretKey = getSecretKey();
        new Ajax.Request(urlConfig.setBackupSchedule, {
            parameters: backupScheduleInfo,
            method: 'post',
            onSuccess: function(transport) { setBackupScheduleJSONResponse(transport.responseText); },
            onFailure: function(transport) { setBackupScheduleJSONResponse(transport.responseText); }
        });
    }
    else if (atleastOneChecked && timeOfBackupIsValid) {
        backupScheduleInfo.sunday = days[0] ? days[0].checked : false;
        backupScheduleInfo.monday = days[1] ? days[1].checked : false;
        backupScheduleInfo.tuesday = days[2] ? days[2].checked : false;
        backupScheduleInfo.wednesday = days[3] ? days[3].checked : false;
        backupScheduleInfo.thursday = days[4] ? days[4].checked : false;
        backupScheduleInfo.friday = days[5] ? days[5].checked : false;
        backupScheduleInfo.saturday = days[6] ? days[6].checked : false;
        backupScheduleInfo.timeOfBackup = finalDate;
        backupScheduleInfo.secretKey = getSecretKey();
        backupScheduleInfo.timezoneOffset = new Date().getTimezoneOffset();
        new Ajax.Request(urlConfig.setBackupSchedule, {
            parameters: backupScheduleInfo,
            method: 'post',
            onSuccess: function(transport) { setBackupScheduleJSONResponse(transport.responseText); },
            onFailure: function(transport) { setBackupScheduleJSONResponse(transport.responseText); }
        });
    } else {
        var errors = [];
        if (!atleastOneChecked) {
            errors.push(Translator.translate('backupAndRestore.messages.mustCheckAtLeastOneDay'));
        }
        if (!timeOfBackupIsValid) {
            errors.push(Translator.translate('backupAndRestore.messages.mustEnterBackupTimeIn24Format'));
        }

        // show the errors
        var stringList = '<p>';
        errors.each(function(err) { // display each error
            stringList += err + '<br />';
        });
        stringList += '</p>';
        var localMsgArea = $('section_31_0_messages');
        var localTmpId = localMsgArea.readAttribute('id') + '_' + (Math.floor(Math.random() * 10000));
        localMsgArea.update().insert({ bottom: '<div id="' + localTmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + stringList + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + localTmpId + '\');"></div><div style="clear:both;"></div></div>' });
    }

﻿}

﻿function setBackupScheduleJSONResponse(backupScheduleResponse) {
    var JobErrorResponse = backupScheduleResponse.evalJSON(true).BackupScheduleResponse;
    var sectionId = 'section_31_0';
    var contentBlockDivId = 'block_section_31_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            onLoadBackupPage();
            // Insert new Success message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            if ($('days').innerHTML == '') {
                $('days').innerHTML = Translator.translate("generic.none");
            }
        } else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
﻿}

//Alert Management

﻿function displayAlert(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.AlertInfo) {
        var alertData = data.AlertInfo;
        $('number_of_alerts').innerHTML = alertData.currentNumber.length == 0 ? '0' : alertData.currentNumber;
        $('max_of_alerts').innerHTML = alertData.maxNumber.length == 0 ? Translator.translate('generic.notConfigured') : alertData.maxNumber;
        $('days_to_retain').innerHTML = alertData.daysToRetain.length == 0 ? Translator.translate('generic.notConfigured') : alertData.daysToRetain;
        $('timeout_for_duplicates').innerHTML = alertData.timeOutForDuplicates.length == 0 ? Translator.translate('generic.notConfigured') : alertData.timeOutForDuplicates;
    }
﻿}

﻿var AlertInfo = Class.create({
    initialize: function() {
        this.currentNumber = 0;
        this.maxNumber = 0;
        this.daysToRetain = 0;
        this.timeOutForDuplicates = 0;
        this.rowsToClean = 0;
        this.cleanUpInterval = 60000;
        this.secretKey = '';
    }
﻿});

﻿function setAlert(form) {
    var alertInfo = new AlertInfo();
    if ($('max_of_alerts').value == Translator.translate('generic.notConfigured')) {
        alertInfo.maxNumber = '';
    } else {
        alertInfo.maxNumber = $('max_of_alerts').value;
    }
    if ($('days_to_retain').value == Translator.translate('generic.notConfigured')) {
        alertInfo.daysToRetain = '';
    } else {
        alertInfo.daysToRetain = $('days_to_retain').value;
    }
    if ($('timeout_for_duplicates').value == Translator.translate('generic.notConfigured')) {
        alertInfo.timeOutForDuplicates = '';
    } else {
        alertInfo.timeOutForDuplicates = $('timeout_for_duplicates').value;
    }
    alertInfo.secretKey = getSecretKey();
    new Ajax.Request(urlConfig.setAlert, {
        parameters: alertInfo,
        method: 'post',
        onSuccess: function(transport) { setAlertJSONResponse(transport.responseText); },
        onFailure: function(transport) { setAlertJSONResponse(transport.responseText); }
    });
﻿}

﻿function setAlertJSONResponse(alertResponse) {
    var JobErrorResponse = alertResponse.evalJSON(true).AlertResponse;
    var sectionId = 'section_4_0';
    var contentBlockDivId = 'block_section_4_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
             onLoadAlertsPage();
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        } else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
﻿}

// Change Admin Password

﻿var PasswordInfo = Class.create({
    initialize: function() {
        this.currentPassword = '';
        this.newPassword = '';
        this.vNewPassword = '';
    }
﻿});

﻿function changeAdminPassword() {
    // Hide any old Success message using a blind up effect.
    $('section_9_0_messages').select('div.msgSuccess').each(function(item) { item.blindUp(); });
    $('section_9_0_messages').select('div.msgFailure').each(function(item) { item.blindUp(); });

    var passwordInfo = new PasswordInfo();
    passwordInfo.currentPassword = $('current_password').value;
    passwordInfo.newPassword = $('new_password').value;
    passwordInfo.vNewPassword = $('verify_new_password').value;

    // Reset the form fields to blank.
    $('current_password').value = '';
    $('new_password').value = '';
    $('verify_new_password').value = '';

    new Ajax.Request(urlConfig.changePassword, {
        parameters: passwordInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setPasswordJSONResponse(transport.responseText); },
        onFailure: function(transport) { setPasswordJSONResponse(transport.responseText); }
    });
﻿}

﻿function setPasswordJSONResponse(passwordResponse) {
    var JobErrorResponse = passwordResponse.evalJSON(true).PasswordResponse;
    var sectionId = 'section_9_0';
    var contentBlockDivId = 'block_section_9_0_0_0';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Set one of SimpleForm's properties with the content block's inner HTML.
            setSimpleFormContentBlock(contentBlockDivId);
        } else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
﻿}

﻿var NetworkInfo = Class.create({
    initialize: function() {
        this.hostName = "localhost";
        this.ipAddress = "";
        this.subnetMask = "";
        this.primaryDNS = "";
        this.secondaryDNS = "";
        this.defaultGateway = "";
        this.ntpServer = "";
    }
﻿});

﻿function displayNetworkInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.NetworkInfo) {
        var netInfo = data.NetworkInfo;
        $('host_name').innerHTML = netInfo.hostName;
        $('tcp_ip_address').innerHTML = netInfo.ipAddress;
        $('subnet_mask').innerHTML = netInfo.subnetMask;
//        $('default_gateway').innerHTML = netInfo.defaultGateway;
        $('primary_dns').innerHTML = netInfo.primaryDNS;
        $('secondary_dns').innerHTML = netInfo.secondaryDNS;

    }
﻿}

﻿var EncryptionPasswordInfo = Class.create({
    initialize: function() {
        this.password = '';
        this.vPassword = '';
    }
﻿});


﻿function setEncryptionPassword(form) {

    var passwordInfo = new EncryptionPasswordInfo();

    passwordInfo.password = $('encpassword').value;
    passwordInfo.vPassword = $('vencpassword').value;

    new Ajax.Request(urlConfig.setEncryptionPassword, {
        parameters: passwordInfo,
        method: urlConfig.postMethod,
        onSuccess: function(transport) { setEncryptionPasswordJSONResponse(transport.responseText); },
        onFailure: function(transport) { setEncryptionPasswordJSONResponse(transport.responseText); }
    });
﻿}

﻿function setEncryptionPasswordJSONResponse(encryptionPasswordResponse) {
    var JobErrorResponse = encryptionPasswordResponse.evalJSON(true).EncryptionPasswordResponse;
    var sectionId = 'section_32_0';
    var contentBlockDivId = 'block_section_32_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.

            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Hide (display: none) the Password table row.
            if ($('encpassword')) {
                if ($('encpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('encpassword').up('tr').addClassName('hidden');

                }
                $('encpassword').innerHTML = '';
            }

            // Hide (display: none) the Verify Password table row.
            if ($('vencpassword')) {
                if ($('vencpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('vencpassword').up('tr').addClassName('hidden');
                }
                $('vencpassword').innerHTML = '';

            }

        } else {
            // Hide any old Start or Failure message using a blind up effect.
            $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.blindUp(); });
            $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }


    }
﻿}

﻿function displayEncryptionPassword(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.EncryptionPasswordInfo) {
        var passwordInfo = data.EncryptionPasswordInfo;
        $('encpassword').innerHTML = passwordInfo.password;
        $('vencpassword').innerHTML = passwordInfo.vPassword;

    }
﻿}


﻿var ApplianceCertificateInfo = Class.create({
    initialize: function() {
        this.issuedTo;
        this.issuedBy;
        this.validFrom;
    }
﻿});

﻿function displayApplianceCertificateInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ApplianceCertificateInfo) {
        var info = data.ApplianceCertificateInfo;
        $('issued_by').innerHTML = info.issuedBy;
        $('issued_to').innerHTML = info.issuedTo;
        $('valid_from').innerHTML = info.validFrom;

    }
﻿}

﻿function displayTarball(transport) {
    //alert('displayTarball: ' + transport.responseText);
    var JobErrorResponse = transport.responseText.evalJSON(true).GetTarballResponse;
    if (JobErrorResponse.responseCode == 0) {
        var msg = Translator.translate('applianceManagement.downloadBundleInstructions') + '<p><p><a ' +
            'class=\"modalIconLink\"' + 'href="'
                + JobErrorResponse.errorMessage + '">' + Translator.translate("applianceManagement.downloadBundleLink") + '</a>';
        displayModalResult(msg, Translator.translate('generic.close'), 'statusLargeSuccessIcon');
    } else {
        displayModalResult(JobErrorResponse.errorMessage, Translator.translate('generic.close'), 'statusLargeCriticalIcon');
    }
﻿}


﻿function displayModalResult(messageContent, buttonName, iconType) {
    var selector = $('update_status');
    var checkbox = document.createElement('div');
    selector.innerHTML = messageContent;
    checkbox.setAttribute('class', 'statusLargeIcon ' + iconType);
    Element.replace($('update_status_icon'), checkbox);

    //$('block_section_modalContent_0_0_0').insert({ bottom: messageContent });
    $('tarball_button').innerHTML = buttonName;
﻿}

﻿var LicenseInfo = Class.create({
    initialize: function() {
        this.maxVCenters = "0";
        this.maxHosts = "0";
        this.vCentersUsed = "0";
        this.vCentersRemaining = "0";
        this.hostsUsed = "0";
        this.hostsRemaining = "0";
        this.hostsUnlicensed = "0";
    }
﻿});

﻿function displayLicenseInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.LicenseInfo) {

        //Hide all the informaion and warning messages so that they appear later based on the license state.
        $('unlicensedHostsRow').hide();
        $('hostLicenseWarning').hide();
        $('hostLicenseNoRemaining').hide();

        var info = data.LicenseInfo;
        $('maxVCenters').innerHTML = info.maxVCenters;
        $('maxHosts').innerHTML = info.maxHosts;
        $('vCentersUsed').innerHTML = info.vCentersUsed;
        $('vCentersRemaining').innerHTML = info.vCentersRemaining;
        $('hostsUsed').innerHTML = info.hostsUsed;
        //If the host license is unlimited, then don't check anything else.
        if (info.maxHosts == -1) {
            $('hostsRemaining').up('tr').addClassName('hidden');
            $('maxHosts').innerHTML = Translator.translate("generic.unlimited");
        }
            //If the license is not unlimited
        else {
            $('hostsRemaining').up('tr').removeClassName('hidden');
            $('hostsRemaining').innerHTML = info.hostsRemaining;
            var iHostsUsed = parseInt(info.hostsUsed);
            var iMaxHosts = parseInt(info.maxHosts);
            if (iMaxHosts == 1) {
                // Trial license, ensure the link to purchase is shown
                $('license_purchase_link').show();
            } else {
                // Hide the link to purchase the license
                $('license_purchase_link').hide();
            }
            if (iHostsUsed > iMaxHosts) {
                $('unlicensedHosts').innerHTML = iHostsUsed - iMaxHosts;
                $('unlicensedHostsRow').show();
                $('hostLicenseWarning').show();
            } else if (iHostsUsed == iMaxHosts) {
                $('hostLicenseNoRemaining').show();
            }
        }
        if (info.vCentersUsed == info.maxVCenters) {
            $('vCenterLicenseInfo').show();
        }

    }
﻿}

﻿function onVCenterPageLoad() {
    var request1 = new Ajax.Request(urlConfig.getLicenseInfo, {
        method: 'get',
        onComplete: function(transport) {
            displayLicenseInfo(transport);
        }
    });
    var request2 = new Ajax.Request(urlConfig.getVCenters, {
        method: 'get',
        onComplete: function(transport) {
            displayVCenters(transport);
        }
    });
﻿}

﻿var ApplianceUpdate = Class.create({
    initialize: function() {
        this.repositoryPath = Translator.translate("generic.notDetermined");
        this.currentVersion = Translator.translate("generic.notDetermined");
        this.availableVersion = Translator.translate("generic.notDetermined");
        this.upgradePossible = false;
        this.defaultURL = Translator.translate("generic.notDetermined");

    }
﻿});

﻿function displayApplianceUpdateInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ApplianceUpdate) {
        var info = data.ApplianceUpdate;
        $('current_appliance_version').innerHTML = info.currentVersion;
        $('available_appliance_version').innerHTML = info.availableVersion;
        $('repositoryPath').innerHTML = info.repositoryPath;
        $('upgradePossible').value = info.upgradePossible;
        $('defaultURL').innerHTML = info.defaultURL;
    }
﻿}

﻿var NetworkShareInfo = Class.create({
    initialize: function() {
        this.share = "";
        this.user = "";
        this.password = "";
        this.folder = true;
    }
﻿});

﻿var SecurityObject = Class.create({
    initialize: function() {
        this.secretKey = "";
    }
﻿});


﻿function restoreCertificate() {
    // Disable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $('section_modalContent_0').select('.sectionEditButtons button').each(function(item) {
        item.disabled = true;
        item.removeClassName('stdButtonEmphasized1');
        item.addClassName('stdButtonDisabled');
    });

    enableProcessingInModal(Translator.translate("generic.pleaseWait") + "...");
    var securityObject = new SecurityObject();
    securityObject.secretKey = getSecretKey();
    var request = new Ajax.Request(urlConfig.restoreCertificate, {
        parameters: securityObject,
        method: 'post',
        onSuccess: function(transport) { setGenericJSONResponse('section_5_0', transport.responseText); },
        onFailure: function(transport) { setGenericJSONResponse('section_5_0', transport.responseText); }
    });
﻿}

﻿function setGenericJSONResponse(sectionId, virtualApplianceActionResponse) {
    var JobErrorResponse = virtualApplianceActionResponse.evalJSON(true).VirtualApplianceActionResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = sectionId + '_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.success") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    } else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.failed") + '</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
﻿}

﻿function showStartMsg(sectionId) {
    var sectionMessagesId = sectionId + '_messages';

    // Hide any old Failure or Success message using a blind up effect.
    $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });

    // Display only one (generic) Starting message.
    if ($(sectionMessagesId).down('div#divMsgStarting', 0)) {
        $(sectionMessagesId).select('div#divMsgStarting').each(function(item) { item.setStyle({ display: '' }); });
    } else {
        $(sectionMessagesId).insert({ bottom: '<div id="divMsgStarting" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.processing") + '</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("generic.pleaseWait") + '...</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'divMsgStarting\');"></div></div>' });
    }
﻿}

﻿var NtpSettings = Class.create({
    initialize: function() {
        this.enabled;
        this.ntpPreferred;
        this.ntpSecondary;
    }
﻿});

﻿function displayNtpSettings(transport, shouldClearMessages) {
    var data = transport.responseText.evalJSON(true);
    
    if (shouldClearMessages) {
        // Hide any old Failure or Success message using a blind up effect.
        var sectionMessagesId = 'section_3_0_messages';
        $(sectionMessagesId).select('div.msgFailure').each(function(item) { item.blindUp(); });
        $(sectionMessagesId).select('div.msgSuccess').each(function(item) { item.blindUp(); });
    }

    if (data.NtpSettings) {
        var settings = data.NtpSettings;
        $('enabled').value = settings.enabled == true ? Translator.translate('generic.enabled') : Translator.translate('generic.disabled');
        $('enabled').innerHTML = settings.enabled == true ? Translator.translate('generic.enabled') : Translator.translate('generic.disabled');
        var ntpStandard = $('ntp_standard');
        if (settings.enabled) {
            var tmpId = '_' + (Math.floor(Math.random() * 10000));
            if (ntpStandard)
                ntpStandard.innerHTML = '<div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.info") + '.</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("applianceManagement.vmwareToolsTimeSyncOptionDisabled") + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'ntp_standard\');"></div></div>';
            else
                $('section_3_0_messages').insert({ bottom: '<div id="ntp_standard" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">' + Translator.translate("generic.info") + '.</div></td><td class="maxWidthCol"><div class="msgText">' + Translator.translate("applianceManagement.vmwareToolsTimeSyncOptionDisabled") + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'ntp_standard\');"></div></div>' });
        } else {
            if (ntpStandard)
                ntpStandard.remove();
        }

        if (settings.ntpPreferred != '') {
            $('ntpPreferred').innerHTML = settings.ntpPreferred;
        }

        if (settings.ntpSecondary != '') {
            $('ntpSecondary').innerHTML = settings.ntpSecondary;
        }
    }
﻿}

﻿function displayBackupSettings(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.BackupSettings) {
        var settings = data.BackupSettings;
        $('backupLocation').innerHTML = settings.backupLocation;
        $('userName').innerHTML = settings.userName;
    }
﻿}
﻿
function refreshNTPSettings() {
    new Ajax.Request(urlConfig.getNtpSettings, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayNtpSettings(transport, false);
        }
    });
}


﻿function refreshNTPonCancel() {

    cancelEditMode('section_3_0');
    new Ajax.Request(urlConfig.getNtpSettings, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayNtpSettings(transport, true);
        }
    });
﻿}

var TimeZoneOffset = Class.create({
    initialize: function() {
        this.timezoneOffset = 0;
    }
﻿});


var UpdateStatus = Class.create({
    initialize: function() {
        this.updateStatus;
    }
﻿});

function displayApplianceUpdateStatus(transport) {
    var data = transport.responseText.evalJSON(true);
    if ( data.UpdateStatus ) {
        var updateInfo = data.UpdateStatus;
        if( updateInfo.updateStatus == "Failed"){
        	openModalAndCloseSectionMessage(urlConfig.applianceUpdateFailed,'halfWidth',0);
        }
    }
﻿}

function onLoadIndexPage() {
	new Ajax.Request(urlConfig.getApplianceUpdateStatus, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
        	displayApplianceUpdateStatus(transport);
        }
    });
}

﻿function onLoadBackupPage() {

    $$('.sectionEditButton').each(function(item) { item.addClassName('disabled'); });
    var timeZoneInfo = new TimeZoneOffset();
    timeZoneInfo.timezoneOffset = new Date().getTimezoneOffset();

    new Ajax.Request(urlConfig.getBackupSettings, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayBackupSettings(transport);
        }
    });

    new Ajax.Request(urlConfig.getBackupSchedule, {
    	parameters: timeZoneInfo,
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayBackupSchedule(transport);
        }
    });
    $$('.sectionEditButton').each(function(item) { item.removeClassName('disabled'); });
﻿}

﻿function displayCurrentVersion(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ApplianceUpdate) {
        var versionData = data.ApplianceUpdate;
        var version = versionData.currentVersion;
        var build = Translator.translate('mainMenu.buildNotDetermined');
        var index = version.lastIndexOf(".");
        build = version.substring(index + 1);
        version = version.substring(0, index);
        $('version').innerHTML = version;
        $('build').innerHTML = build;
    }
﻿}

﻿function buildTimeZoneDesignation( ) {
    var date = new Date();
    var timeZoneAsString = "GMT";
    var offset = date.getTimezoneOffset();
    if ((offset / 60 > 0) && (offset / 60 < 10)) {
        timeZoneAsString = timeZoneAsString + "-" + (offset / 60);
    } else if ((offset < 0) && (offset / 60 > -10)) {
        timeZoneAsString = timeZoneAsString + "+" + (-1 * offset / 60);
    }
    return timeZoneAsString;

﻿}

﻿function refreshApplianceUpdateInfo() {
    var ajaxRequest = new Ajax.Request(urlConfig.getApplianceUpdateInfo, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayApplianceUpdateInfo(transport);
        }
    });
﻿}

﻿function enableProcessingInModal(message) {
    $('block_section_modalContent_0_0_0').innerHTML = '<div id="divNewMsgStarting"><div style="float:left;margin:15px 20px 15px 0px;"><img id="update_status_icon" src="images/loading_icon.gif" alt="" /></div><div id="update_status" style="float:left;margin:20px 0;width:260px;">' + message + '</div></div>';
﻿}

﻿function submitLogout() {
    window.location.href = "j_spring_security_logout";
﻿}

﻿function clearTestConnectionResult() {
    $('val_icn_app_update').removeClassName('val-fail');
    $('val_icn_app_update').removeClassName('val-success');
    $('val_icn_app_update').removeClassName('val-waiting');
    $('val_msg_app_update').innerHTML = '';
﻿}

﻿function clearBackupSettingsPassword() {
    $('backupLocationPassword').innerHTML = "";
    $('encryptionPassword').innerHTML = "";
    $('encryptionVPassword').innerHTML = "";
﻿}

﻿function clearProxyPassword() {
    $('password').innerHTML = "";
    if ($('useCreds').innerHTML == Translator.translate('generic.no')) {
        $('username').innerHTML = "";
    }
﻿}

﻿function resetProxyPassword() {
    new Ajax.Request(urlConfig.getProxy, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) { displayProxy(transport); },
        onFailure: function(transport) { displayProxy(transport); }
    });

﻿}

function reloadAutomaticBackupSchedule(){
	var timeZoneInfo = new TimeZoneOffset();
    new Ajax.Request(urlConfig.getBackupSchedule, {
    		    parameters: timeZoneInfo,
                method: 'get',
                asynchronous: false,
                onComplete: function(transport) {
                    displayBackupSchedule(transport);
                }
            });
}

﻿function clearBackupSettingsForm() {
    new Ajax.Request(urlConfig.getBackupSettings, {
        method: 'get',
        onComplete: function(transport) {
            displayBackupSettings(transport);
        }
    });
﻿}

﻿function onLoadAppliancePage() {

    $$('.sectionEditButton').each(function(item) { item.addClassName('disabled'); });

    refreshApplianceUpdateInfo();

    new Ajax.Request(urlConfig.getNetworkInfo, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayNetworkInfo(transport);
        }
    });

    new Ajax.Request(urlConfig.getApplianceCertificateInfo, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayApplianceCertificateInfo(transport);
        }
    });

    new Ajax.Request(urlConfig.getNtpSettings, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayNtpSettings(transport, true);
        }
    });

    new Ajax.Request(urlConfig.getProxy, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayProxy(transport);
        },
        onFailure: function(transport) { displayProxy(transport); }
    });

    $$('.sectionEditButton').each(function(item) { item.removeClassName('disabled'); });

﻿}

﻿function onLoadAlertsPage() {

    $$('.sectionEditButton').each(function(item) { item.addClassName('disabled'); });

    new Ajax.Request(urlConfig.getAlert, {
        method: 'get',
        asynchronous: false,
        onComplete: function(transport) {
            displayAlert(transport);
        }
    });

    $$('.sectionEditButton').each(function(item) { item.removeClassName('disabled'); });
﻿}

﻿function checkForSecurityAndLogout(strMsg) {

    if (strMsg.match('AdminPortalSecurityException')) {
        alert(Translator.translate('generic.errors.webRequestAuthorizationFailed'));
        window.location.href = "j_spring_security_logout";
    }
﻿}

﻿function getSecretKey() {
    // @CSRF
    if (!$.sessionizer.isAvailable()) {
        return $('fldSecretKey').value;
    } else {
        return $.sessionizer.get('secretKey');
    }
﻿}


﻿function getLocalDateTime(utcDateTime) {
    if (utcDateTime == Translator.translate("generic.notConfigured") || utcDateTime == Translator.translate("generic.unknown")) {
        return 'NaN';
    }
    var now = new Date();
    var offset = now.getTimezoneOffset();
    offset = offset * 1000 * 60;
    var timeInMillis = Date.parse(utcDateTime);
    var finalDate = new Date();
    if (offset > 0) {
        finalDate.setTime(timeInMillis - offset);
    } else {
        finalDate.setTime(timeInMillis +  Math.abs(offset));
    }
    finalDate = new Date(finalDate.getFullYear(), finalDate.getMonth(), finalDate.getDate(), finalDate.getHours(), finalDate.getMinutes(), 0);
    return finalDate;

﻿}

﻿function getTimePart(time) {
    var timeValue = time.split(":", 3);
    if (timeValue.length >= 2) {
        if (timeValue[0].length == 1) {
            timeValue[0] = "0" + timeValue[0];
        }
        if (timeValue[1].length == 1) {
            timeValue[1] = "0" + timeValue[1];
        }
        return timeValue[0] + ":" + timeValue[1];
    } else {
        return time;
    }
﻿}
function loadSortedCountryList() {
    var ajaxRequest = new Ajax.Request(urlConfig.sortedCountryList, {
        method: 'get',
        onComplete: function(transport) {
            var options = transport.responseText.evalJSON(true).options;
            var countrySelect = $('country');
            var selectText = Translator.translate('generic.selectCountry');
            var optSelectCountry = document.createElement('option');
      optSelectCountry.text = selectText;
      optSelectCountry.value = "";
      countrySelect.options.add(optSelectCountry);
            options.each(function(option) {
                var opt = document.createElement('option');
        opt.text = option.text;
        opt.value = option.value;
        countrySelect.options.add(opt);
            });
        }
    });
}