Ajax.Request.prototype.setRequestHeaders = Ajax.Request.prototype.setRequestHeaders.wrap(
function (original) {
    this.transport.setRequestHeader("If-Modified-Since", "Thu, 1 Jan 1970 00:00:00 GMT");
    original(); // then call the original version
});

Ajax.JSON = Class.create(Ajax.Request, {
    initialize: function ($super, url, options) {
        options = options || {};
        options.contentType = 'application/json;charset=utf-8';
        options.postBody = Object.toJSON(options.object);
        $super(url, options);
    }
});


//Register the exception handler.
//Currently being used for session time-out.
Ajax.Responders.register({
 onException: function (transport, exception) {
	 	var strMsg = exception.message;
	 	checkForSecurityAndLogout(strMsg);
	 	if (strMsg.match('loginForm')) {
         //alert('The current session has timed-out');
         window.location.href = 'login.jsp?timeout=true';
	 	}
 	}
});

function checkSession(url, specialModalClass){
	new Ajax.Request(urlConfig.checkSession, { method: 'get',
	        onComplete: function (transport) {
		       if (transport != null && transport.responseText.match('loginForm')) {
		    		//alert('The current session has timed-out');
		    		window.location.href = 'login.jsp?timeout=true';
		 	    }
		    	else {
		    		if(url != "" && specialModalClass != ""){
		    			openModal(url, specialModalClass);
		    		}
		    	}
            }
		 });
 }

function openModalAndCheckSession(url, specialModalClass){
	checkSession(url,specialModalClass);
	
}


function openModalAndCloseSectionMessage(url, specialModalClass, itemArgs) {
    if ($('section_2_0_messages')) {
        for (var i = 0; i < 100; i++) {
            if ($('section_2_0_messages').down('div.msgSuccess', i)) {
                $('section_2_0_messages').down('div.msgSuccess', i).blindUp();
            }
        }
    }
    openModalAndCheckSession(url, specialModalClass);
    if (itemArgs != null && itemArgs.length > 1) {
        var vCenterInfoArray = itemArgs.split('^');
        var vCenterInfo = new VCenterInfo();
        vCenterInfo.machineId = vCenterInfoArray[0];
        vCenterInfo.machineName = vCenterInfoArray[1];
        vCenterInfo.machineIp = vCenterInfoArray[2];
        vCenterInfo.userName = vCenterInfoArray[3];
        vCenterInfo.password = vCenterInfoArray[4];
        vCenterInfo.vPassword = vCenterInfoArray[4];
        VCenter.selectedVCenter = vCenterInfo
    }
}
var SimpleForm = {
    contentBlockDivInnerHTML: null,
    contentBlockDiv4InnerHTML: null,
    contentBlockDiv5InnerHTML: null,
    contentBlockDiv30InnerHTML: null,
    contentBlockDiv31InnerHTML: null,
    contentBlockDiv9InnerHTML: null
};

function setSimpleFormContentBlock(contentBlockDivId) {
    if ($(contentBlockDivId)) {
        switch (contentBlockDivId) {
            case '1':
                SimpleForm.contentBlockDivInnerHTML = $(contentBlockDivId).innerHTML;
                break;
            case 'block_section_4_0_0_1':
                SimpleForm.contentBlockDiv4InnerHTML = $(contentBlockDivId).innerHTML;
                break;
            case 'block_section_5_0_0_1':
                SimpleForm.contentBlockDiv5InnerHTML = $(contentBlockDivId).innerHTML;
                break;
            case 'block_section_30_0_0_1':
                SimpleForm.contentBlockDiv30InnerHTML = $(contentBlockDivId).innerHTML;
                break;
            case 'block_section_31_0_0_1':
                SimpleForm.contentBlockDiv31InnerHTML = $(contentBlockDivId).innerHTML;
                break;
            case 'block_section_9_0_0_0':
                SimpleForm.contentBlockDiv9InnerHTML = $(contentBlockDivId).innerHTML;
                break;
        }
    }
}

function getSimpleFormContentBlock(contentBlockDivId) {
    if ($(contentBlockDivId)) {
        switch (contentBlockDivId) {
            case '1':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDivInnerHTML;
                break;
            case 'block_section_4_0_0_1':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv4InnerHTML;
                break;
            case 'block_section_5_0_0_1':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv5InnerHTML;
                break;
            case 'block_section_30_0_0_1':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv30InnerHTML;
                break;
            case 'block_section_31_0_0_1':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv31InnerHTML;
                break;
            case 'block_section_9_0_0_0':
                $(contentBlockDivId).innerHTML = SimpleForm.contentBlockDiv9InnerHTML;
                break;
        }
    }
}

function applyEditModeForSimpleForm(sectionId, functionName) {
    if ($(sectionId)) {
        if ($(sectionId).down('form')) {
            var form = $(sectionId).down('form');
        } else if ($(sectionId).up('form')) {
            var form = $(sectionId).up('form');
        }

        if (form) {
            if (functionName != null) {
                var rez = eval(functionName(form));
            }
        }

        // closing a section edit mode should not be here as it won't
        // account for the ajax response, only client-side validation
        /*if(rez != false){
            toggleSectionEditMode(sectionId);
        }*/
        cacheSectionForTogglingEditMode.sectionID = sectionId;
        
    }
}

/**
 * The only reason this exists is so that an inline form (on a page, not in
 * a modal) can stay in edit mode if an error is returned from the ajax
 * call. This is only used by the Automatic Scheduled Backups area as of
 * 3.28.11.
 */
var cacheSectionForTogglingEditMode = {
    sectionID:false,
    toggle:function(){
        toggleSectionEditMode( this.sectionID );
    }
}


function editButtonClickForSimpleForm(sectionId, contentBlockDivId) {
    if ($(sectionId)) {
        if ($(sectionId).down('form')) {
            var form = $(sectionId).down('form');
        } else if ($(sectionId).up('form')) {
            var form = $(sectionId).up('form');
        }
    }
    if (form && !$(sectionId).down('div.sectionEditButton.disabled')) {
        if (form.down('span#vpassword')) {
            if (form.down('span#vpassword').up('tr')) {
                // Unhide the Verify Password table row.
                form.down('span#vpassword').up('tr').removeClassName('hidden');
            }
        }
        if (form.down('span#password')) {
            if (form.down('span#password').up('tr')) {
                // Unhide the Password table row.
                form.down('span#password').up('tr').removeClassName('hidden');
            }
        }
        
        if (form.down('span#vencpassword')) {
            if (form.down('span#vencpassword').up('tr')) {
                // Unhide the Verify Password table row.
                form.down('span#vencpassword').up('tr').removeClassName('hidden');
            }
        }
        if (form.down('span#encpassword')) {
            if (form.down('span#encpassword').up('tr')) {
                // Unhide the Password table row.
                form.down('span#encpassword').up('tr').removeClassName('hidden');
            }
        }
        
        
        setSimpleFormContentBlock(contentBlockDivId);
    }
    editButtonClick(sectionId);
}

function hidePasswordTR() {
    if ($('password')) {
        if ($('password').up('tr')) {
            $('password').up('tr').addClassName('hidden')
        }
    }
}

function hideVPasswordTR() {
    if ($('vpassword')) {
        if ($('vpassword').up('tr')) {
            $('vpassword').up('tr').addClassName('hidden')
        }
    }
}

function hideEncPasswordTR() {
    if ($('encpassword')) {
        if ($('encpassword').up('tr')) {
            $('encpassword').up('tr').addClassName('hidden')
        }
    }
}

function hideVEncPasswordTR() {
    if ($('vencpassword')) {
        if ($('vencpassword').up('tr')) {
            $('vencpassword').up('tr').addClassName('hidden')
        }
    }
}
function showEditPassMsg(){
	if ($('modifyPassword')) {
        if ($('modifyPassword').up('tr')) {
            $('modifyPassword').up('tr').removeClassName('hidden')
        }
    }
}

function hideEditPassMsg(){
	if ($('modifyPassword')) {
        if ($('modifyPassword').up('tr')) {
            $('modifyPassword').up('tr').addClassName('hidden')
        }
    }
}
function cancelButtonClickWithoutEditMode(contentBlockDivId, sectionMessagesId) {
    if (contentBlockDivId == 'block_section_9_0_0_0') {
        // Reset the admin password form fields to blank.
        if ($('current_password')) {
            $('current_password').value = '';
        }
        if ($('new_password')) {
            $('new_password').value = '';
        }
        if ($('verify_new_password')) {
            $('verify_new_password').value = '';
        }
    }

    getSimpleFormContentBlock(contentBlockDivId);

    // Hide any old Failure or Success message using a blind up effect.
    $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function (item) { item.blindUp(); });
}

function disableEditButtonsAndShowStartMsg(sectionId) {
        var sectionMessagesId = sectionId + '_messages';
    
    // Disable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $(sectionId).select('.sectionEditButtons button').each(function (item) {
        item.disabled = true;
        item.removeClassName('stdButtonEmphasized1');
        item.addClassName('stdButtonDisabled');
    });
    
        // Hide any old Failure or Success message using a blind up effect.
        $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
        $(sectionMessagesId).select('div.msgSuccess').each(function (item) { item.blindUp(); });

    // Display only one (generic) Starting message.
        if ($(sectionMessagesId).down('div#divMsgStarting', 0)) {
            $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.setStyle({ display: '' }) });
        }
        else {
            $(sectionMessagesId).insert({ bottom: '<div id="divMsgStarting" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Processing</div></td><td class="maxWidthCol"><div class="msgText">Please wait.....</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'divMsgStarting\');"></div></div>' });
    }
}

function enableEditButtonsAndHideMsg(sectionId) {
    var sectionMessagesId = sectionId + '_messages';

    // Enable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $(sectionId).select('.sectionEditButtons button').each(function (item) {
        item.disabled = false;
        if (item.type && item.type == 'submit') { item.addClassName('stdButtonEmphasized1') };
        item.removeClassName('stdButtonDisabled');
    });
    // Hide any old Start, Failure, or Success message using a blind up effect.
    $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function (item) {  item.blindUp(); });
}

function hideMsgUsingBlindUp(sectionId) {
    // Hide any old Start, Failure, or Success message using a blind up effect.
    var sectionMessagesId = sectionId + '_messages';
    $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function (item) {  item.blindUp(); });
}
//VCenters

var VCenterInfo = Class.create({
    initialize: function () {
        this.machineId = 0;
        this.machineName = '';
        this.machineIp = '';
        this.userName = '';
        this.password = '';
        this.vPassword = '';
    }
});


function registerVCenter() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    // Instantiate a vCenterInfo object and set property values.
    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = 0;
    vCenterInfo.machineName = $('machinename').value == 'Not configured' ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == 'Not configured' ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == 'Not configured' ? '' : $('username').value;
    vCenterInfo.password = $('password').value == 'Not configured' ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == 'Not configured' ? '' : $('vpassword').value;

    // Post the object in JSON format.
    new Ajax.Request(urlConfig.registerVCenter, { parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { registerVCenterJSONResponse(transport.responseText) },
        onFailure: function (transport) { registerVCenterJSONResponse(transport.responseText) }
    });
}



function registerVCenterJSONResponse(vCenterResponse) {
	
	
    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }

        onVCenterPageLoad();
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}



function modifyVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');

    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == 'Not configured' ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == 'Not configured' ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == 'Not configured' ? '' : $('username').value;
    vCenterInfo.password = $('password').value == 'Not configured' ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == 'Not configured' ? '' : $('vpassword').value;
    new Ajax.Request(urlConfig.modifyVCenterCredentials, { parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_0') },
        onFailure: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_0') }
    });
}


function updateVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_3');

    var vCenterInfo = new VCenterInfo();
//    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == 'Not configured' ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == 'Not configured' ? '' : $('machineip').value;
//    vCenterInfo.userName = $('username').value == 'Not configured' ? '' : $('username').value;
//    vCenterInfo.password = $('password').value == 'Not configured' ? '' : $('password').value;
//    vCenterInfo.vPassword = $('vpassword').value == 'Not configured' ? '' : $('vpassword').value;

    new Ajax.Request(urlConfig.updateVCenterCertificate, { parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_3') },
        onFailure: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_3') }
    });
}



function testVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_2');
    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == 'Not configured' ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == 'Not configured' ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == 'Not configured' ? '' : $('username').value;
    vCenterInfo.password = $('password').value == 'Not configured' ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == 'Not configured' ? '' : $('vpassword').value;

    new Ajax.Request(urlConfig.test, { parameters: vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_2') },
        onFailure: function (transport) { modifyVCenterJSONResponse(transport.responseText,'section_modalContent_2') }
    });
}



function modifyVCenterJSONResponse(vCenterResponse, sectionId) {
    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }

        new Ajax.Request(urlConfig.getVCenters, { method: 'get',
            onComplete: function (transport) {
                displayVCenters(transport);
            }
        });
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg(sectionId);
        sectionMessagesId = sectionId+'_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}



function unregisterVCenter(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    
    var vCenterInfo = new VCenterInfo();
    vCenterInfo.machineId = $('machineid').value == '0' ? '' : $('machineid').value;
    vCenterInfo.machineName = $('machinename').value == 'Not configured' ? '' : $('machinename').value;
    vCenterInfo.machineIp = $('machineip').value == 'Not configured' ? '' : $('machineip').value;
    vCenterInfo.userName = $('username').value == 'Not configured' ? '' : $('username').value;
    vCenterInfo.password = $('password').value == 'Not configured' ? '' : $('password').value;
    vCenterInfo.vPassword = $('vpassword').value == 'Not configured' ? '' : $('vpassword').value;
    new Ajax.Request(urlConfig.unregisterVCenter, { parameters:vCenterInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { unregisterVCenterJSONResponse(transport.responseText) },
        onFailure: function (transport) { unregisterVCenterJSONResponse(transport.responseText) }
    });
}



function unregisterVCenterJSONResponse(vCenterResponse) {
    var JobErrorResponse = vCenterResponse.evalJSON(true).VCenterResponse;
    var msgText = JobErrorResponse.errorMessage;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onVCenterPageLoad();
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}


function displayVCenters(transport) {
    var truncateLength = 30;
    var data;
    try{
        data = transport.responseText.evalJSON(true);
    }catch(e){
        data = null;
    }
    
    var vCenterItems = '';
    if (data != null) {
        var strRowStyle = 'oddRow';
        var vCenters = data.VCenters;
        var serverTemplate = new Template('<td><span title="#{machineIp}">#{shortMachineIp}</span></td><td><span title="#{machineName}">#{shortMachineName}</span></td><td><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewModifyModal, \'halfWidth\', \'#{machineId}^#{machineName}^#{machineIp}^#{userName}^#{password}\');">Modify</a></td><td><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewUpdateCredentialsModal, \'halfWidth\', \'#{machineId}^#{machineName}^#{machineIp}^#{userName}^#{password}\');">Update</a></td><td><a class="modalIconLink" href="javascript:openModalAndCloseSectionMessage(urlConfig.viewUnregisterModal, \'halfWidth\', \'#{machineId}^#{machineName}^#{machineIp}^#{userName}^#{password}\');">Unregister</a></td><td class="lastCol"><div></div></td></tr>');
        if (vCenters.length > 0) {
            for (var i = 0; i <= vCenters.length - 1; i++) {
                vCenters[i].shortMachineName = vCenters[i].machineName == "" ? '<i>None</i>' : vCenters[i].machineName.truncate(truncateLength,'...')
                vCenters[i].shortMachineIp   = vCenters[i].machineIp.truncate(truncateLength,'...')
                vCenterItems += '<tr class="' + strRowStyle + '" style="display: table-row;">' + serverTemplate.evaluate(vCenters[i]);
                if (strRowStyle == 'oddRow') {
                    strRowStyle = 'evenRow';
                }
                else {
                    strRowStyle = 'oddRow';
                }
            }
        }
        else {
            // Display 'None'.
            vCenterItems += '<tr class="oddRow" style="display: table-row;"><td colspan="5" style="text-align:center;">No vCenter servers are currently registered</td></tr>'
        }
        vCenterItems += '<tr><td class="tableBottom" colspan="5"></td></tr>';
        $('section_2_0_0_table').down('tbody').replace(vCenterItems);
    }
    else {
        // Display 'None'.
        vCenterItems += '<tr class="oddRow" style="display: table-row;"><td colspan="5" style="text-align:center;">No vCenter servers are currently registered</td></tr>'
            + '<tr><td class="tableBottom" colspan="5"></td></tr>';
        $('section_2_0_0_table').down('tbody').replace(vCenterItems);
    }
    //Draw borders around tables, etc.
    postPageLoadUpdate();
}

var VCenter = {
    selectedVCenter: null
};


//Appliance Management - Appliance Settings

var VirtualApplianceActionInfo = Class.create({
    initialize: function () {
        this.restart = false;
        this.reset = false;
        this.secretKey='';
    }
});

function restartVirtualAppliance() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    
    var virtualApplianceActionInfo = new VirtualApplianceActionInfo();
    virtualApplianceActionInfo.restart = true;
    virtualApplianceActionInfo.secretKey =  getSecretKey();
    new Ajax.Request(urlConfig.restartSpectre, { parameters: virtualApplianceActionInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setVirtualApplianceJSONResponse(transport.responseText) },
        onFailure: function (transport) { setVirtualApplianceJSONResponse(transport.responseText) }
    });
}

function resetVirtualAppliance() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    
    var virtualApplianceActionInfo = new VirtualApplianceActionInfo();
    virtualApplianceActionInfo.reset = true;

    new Ajax.JSON(urlConfig.reset, { object: virtualApplianceActionInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setVirtualApplianceJSONResponse(transport.responseText) },
        onFailure: function (transport) { setVirtualApplianceJSONResponse(transport.responseText) }
    });
}

function setVirtualApplianceJSONResponse(virtualApplianceActionResponse) {
    var JobErrorResponse = virtualApplianceActionResponse.evalJSON(true).SpectreActionInfo;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_2_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}

function openVirtualApplianceActionModalAndCloseSectionMessage(url, specialModalClass) {
    $('section_2_0_messages').select('div.msgSuccess').each(function (item) { item.blindUp(); });
    openModalAndCheckSession(url, specialModalClass);
}

function openUploadCertificateModel() {
    	openVirtualApplianceActionModalAndCloseSectionMessage(urlConfig.viewUploadCertificate, 'halfWidth'); 
 }

//Appliance Management - Proxy Settings
/*
function displayProxy(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ProxyInfo) {
        var proxy = data.ProxyInfo;
        $('enabled').innerHTML = proxy.enabled == true ? 'Enabled' : 'Disabled';
        $('proxy_server').innerHTML = proxy.proxyServer;
        $('port').innerHTML = proxy.port;
        $('username').innerHTML = proxy.userName;
        $('password').innerHTML = proxy.password;
        $('vpassword').innerHTML = '';
    }
}

var ProxyInfo = Class.create({
    initialize: function () {
        this.enabled = false;
        this.proxyServer = '';
        this.port = 0;
        this.userName = '';
        this.password = '';
        this.vPassword = '';
        
    }
});

function setProxy(form) {
    // Disable Cancel and Apply buttons; show Starting message.
    //disableEditButtonsAndShowStartMsg('section_4_0');
	
	var proxyInfo = new ProxyInfo();
    proxyInfo.enabled = Form.getInputs('frmProxy', 'radio', 'enabled').size() != 0 ? (Form.getInputs('frmProxy', 'radio', 'enabled').find(function (radio) { return radio.checked; }).value == 'Enabled' ? true : false) : false;
    proxyInfo.proxyServer = $('proxy_server').value;
    proxyInfo.port = $('port').value;
    proxyInfo.userName = $('username').value;
    proxyInfo.password = $('password').value;
    proxyInfo.vPassword = $('vpassword').value;
    
    new Ajax.Request(urlConfig.setProxy, { parameters: proxyInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setProxyJSONResponse(transport.responseText) },
        onFailure: function (transport) { setProxyJSONResponse(transport.responseText) }
    });
}

function setProxyJSONResponse(proxyResponse) {
    var JobErrorResponse = proxyResponse.evalJSON(true).ProxyResponse;
    var sectionId = 'section_4_0';
    var contentBlockDivId = 'block_section_4_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            //hideMsgUsingBlindUp(sectionMessagesId);
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Hide (display: none) the Password and 'Verify Password' table rows.
            if ($('password')) {
                if ($('password').up('tr')) {
                    // Hide the Password table row.
                    $('password').up('tr').addClassName('hidden');
                }
            }
            if ($('vpassword')) {
                if ($('vpassword').up('tr')) {
                    // Hide the Verify Password table row.
                    $('vpassword').up('tr').addClassName('hidden');
                }
            }
        }
        else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            //enableEditButtonsAndHideMsg(sectionMessagesId');
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
}

//Appliance Management - HTTPS Certificates

var CertificateInfo = Class.create({
    initialize: function () {
        this.content = '';
    }
});

function uploadCertificate() {
    // Disable Cancel and Apply buttons; show Starting message.
    //disableEditButtonsAndShowStartMsg('section_5_0');

    //$('iFrame1').onload = processCertificate;
    $('frmHTTPSCertificate').submit();
}
function processCertificate() {
    //$('iFrame1').onload = '';
    if (true) {
    var certificateInfo = new CertificateInfo();
        if ($('iFrame1').down('CertificateContent')) {
            certificateInfo.content = $('iFrame1').down('CertificateContent').innerHTML;
    }
        $('certificate_content').innerHTML = certificateInfo.content;

    new Ajax.JSON(urlConfig.uploadCertificate, { object: certificateInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setCertificateJSONResponse(transport.responseText) },
        onFailure: function (transport) { setCertificateJSONResponse(transport.responseText) }
    });
    } 
    //else {
    //    setCertificateJSONResponse('{"CertificateResponse":{"responseCode":-1,"errorMessage":"An HTTPS certificate file was not detected. Please Browse to an HTTPS certificate file before clicking Upload.","errorFields":[{"field":"file_to_upload","message":"\u0027File to Upload\u0027 cannot be blank."}]}}');
    //}
}

function deleteCertificate() {
    var certificateInfo = new CertificateInfo();
    if ($('certificate_content')) {
        //certificateInfo.content = $('certificate_content').value;
    }

    new Ajax.JSON(urlConfig.deleteCertificate, { object: certificateInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setCertificateJSONResponse(transport.responseText) },
        onFailure: function (transport) { setCertificateJSONResponse(transport.responseText) }
    });
}

function setCertificateJSONResponse(certificateResponse) {
    var JobErrorResponse = certificateResponse.evalJSON(true).CertificateResponse;
    var sectionId = 'section_5_0';
    var contentBlockDivId = 'block_section_5_0_0_0';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            //hideMsgUsingBlindUp(sectionMessagesId);
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Set one of SimpleForm's properties with the content block's inner HTML.
            setSimpleFormContentBlock(contentBlockDivId);

            // Clear the file input box.
            if ($('span_file_to_upload')) {
                $('span_file_to_upload').innerHTML = $('span_file_to_upload').innerHTML;
            }
        }
        else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            //enableEditButtonsAndHideMsg(sectionMessagesId);
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
}
*/

// Backup and Restore - Backup Now - section_30_0

var BackupNowInfo = Class.create({
    initialize: function () {
        this.backup = false;
    }
});

function backupNow() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    
    var backupInfo = new BackupShareInfo();
    backupInfo.share = $('backup_file_path').value;
    backupInfo.user = $('backup_username').value;
    backupInfo.password = $('backup_password').value;
    backupInfo.encryptionPassword = $('backup_encpassword').value;
    backupInfo.domain = $('backup_domain').value;
    
    new Ajax.Request(urlConfig.backupNow, { parameters: backupInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setBackupNowJSONResponse(transport.responseText) },
        onFailure: function (transport) { setBackupNowJSONResponse(transport.responseText) }
    });
}

function setBackupNowJSONResponse(backupNowResponse) {
    var JobErrorResponse = backupNowResponse.evalJSON(true).BackupNowResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);

    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();

        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_30_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onLoadBackupPage();
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
    	enableEditButtonsAndHideMsg('section_modalContent_0');
    	sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        onLoadBackupPage();
    }
}

function openBackupNowModalAndCloseSectionMessage(url, specialModalClass) {
    // Hide any old Success message using a blind up effect.
    $('section_30_0_messages').select('div.msgSuccess').each(function (item) { item.blindUp(); });

    openModalAndCheckSession(url, specialModalClass);
}

var RestoreInfo = Class.create({
    initialize: function () {
        this.filePath = '';
        this.userName = '';
        this.password = '';
        this.domain = '';
    }
});

// Backup and Restore - Restore Now - _30_0_
function restore() {
    // Disable Cancel and Apply buttons; show Starting message.
    disableEditButtonsAndShowStartMsg('section_modalContent_0');
    var restoreInfo = new BackupShareInfo();
    restoreInfo.share = $('restore_file_path').value;
    restoreInfo.user = $('restore_username').value;
    restoreInfo.password = $('restore_password').value;
    restoreInfo.encryptionPassword = $('restore_encpassword').value;
    restoreInfo.domain = $('restore_domain').value;
    
    new Ajax.Request(urlConfig.restore, { parameters: restoreInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setRestoreJSONResponse(transport.responseText) },
        onFailure: function (transport) { setRestoreJSONResponse(transport.responseText) }
    });
}
function setRestoreJSONResponse(restoreResponse) {
    var JobErrorResponse = restoreResponse.evalJSON(true).RestoreResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;
    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = 'section_30_0_messages';
        tmpId = sectionMessagesId +'_'+  tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
    else {
        sectionMessagesId = 'section_modalContent_0_messages';
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        tmpId = sectionMessagesId + '_' + tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}
//Backup and Restore - Backup Share (Domain, UserName, and Password) Data - _30_0_
function displayBackupShare(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.BackupShareInfo) {
        var backupShareInfo = data.BackupShareInfo;
        $('share').innerHTML = backupShareInfo.share.length == 0 ? 'Not configured' : backupShareInfo.share;
        $('domain').innerHTML = backupShareInfo.domain.length == 0 ? 'Not configured' : backupShareInfo.domain;
        $('username').innerHTML = backupShareInfo.user.length == 0 ? 'Not configured' : backupShareInfo.user;
        $('password').innerHTML = backupShareInfo.password.length == 0 ? '' : backupShareInfo.password;
        $('vpassword').innerHTML = backupShareInfo.vPassword.length == 0 ? '' : backupShareInfo.vPassword;
    }
}

var BackupShareInfo = Class.create({
    initialize: function () {
        this.share = '';
        this.domain = '';
        this.user = '';
        this.password = '';
        this.vPassword = '';
        this.encryptionPassword='';
    }
});

function openRestoreModalAndCloseSectionMessage(url, specialModalClass) {
    // Hide any old Success message using a blind up effect.
    $('section_30_0_messages').select('div.msgSuccess').each(function (item) { item.blindUp(); });

    openModalAndCheckSession(url, specialModalClass);
}

function setBackupShare(form) {
    var backupShareInfo = new BackupShareInfo();
    backupShareInfo.share = $('share').value;
    if($('domain').value != 'Not configured'){
	    backupShareInfo.domain = $('domain').value;
    }

    backupShareInfo.user = $('username').value;
    backupShareInfo.password = $('password').value;
    backupShareInfo.vPassword = $('vpassword').value;

    new Ajax.Request(urlConfig.setBackupShare, { parameters: backupShareInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setBackupShareJSONResponse(transport.responseText) },
        onFailure: function (transport) { setBackupShareJSONResponse(transport.responseText) }
    });
}

function setBackupShareJSONResponse(backupShareResponse) {
    var JobErrorResponse = backupShareResponse.evalJSON(true).BackupShareResponse;
    var sectionId = 'section_30_0';
    var contentBlockDivId = 'block_section_30_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
         // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Hide (display: none) the Password table row.
            if ($('password')) {
                if ($('password').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('password').up('tr').addClassName('hidden');
                }
                $('password').innerHTML='';
            }

            // Hide (display: none) the Verify Password table row.
            if ($('vpassword')) {
                if ($('vpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('vpassword').up('tr').addClassName('hidden');
                }
                $('vpassword').innerHTML='';
            }
        }
        else {
        	// Hide any old Start or Failure message using a blind up effect.
            $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.blindUp(); });
            $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
            
            hidePasswordTR();
        	hideVPasswordTR();
        	
        }


    }
}

// Backup and Restore - Backup Schedule - _31_0_

function displayBackupSchedule(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.BackupScheduleInfo) {
        var backupSchedule = data.BackupScheduleInfo;
        $('enabled_state').innerHTML = backupSchedule.enabled == true ? 'Enabled' : 'Disabled';

        var days = '';
        days = backupSchedule.sunday == true ? 'SU,&nbsp;' : '';
        days += backupSchedule.monday == true ? 'MO,&nbsp;' : '';
        days += backupSchedule.tuesday == true ? 'TU,&nbsp;' : '';
        days += backupSchedule.wednesday == true ? 'WE,&nbsp;' : '';
        days += backupSchedule.thursday == true ? 'TH,&nbsp;' : '';
        days += backupSchedule.friday == true ? 'FR,&nbsp;' : '';
        days += backupSchedule.saturday == true ? 'SA,&nbsp;' : '';

        if (days.length > 7) {
            // Remove the trailing comma and escaped non-breaking space character sequence.
            days = days.substring(0, days.length - 7)
        }
        if (days.length == 0) {
            days = 'Not configured';
        }
        $('days').innerHTML = days;
        if (backupSchedule.timeOfBackup.length > 0) {
        $('timeOfBackup').innerHTML = backupSchedule.timeOfBackup;
        }
        else {
            $('timeOfBackup').innerHTML = 'Not configured';
        }
        $('nextBackup').innerHTML = backupSchedule.nextBackup;
        $('lastBackupDate').innerHTML = backupSchedule.lastBackupDate;
        $('lastBackupStatus').innerHTML = backupSchedule.lastBackupStatus;
        //$('serverTimeZone').innerHTML = backupSchedule.serverTimeZone;
        //$('serverTime').innerHTML = backupSchedule.serverTime;
     }
}

var BackupScheduleInfo = Class.create({
    initialize: function () {
        this.enabled = false;
        this.sunday = false;
        this.monday = false;
        this.tuesday = false;
        this.wednesday = false;
        this.thursday = false;
        this.friday = false;
        this.saturday = false;
        this.timeOfBackup = '';
        this.lastBackupDate = 'Not determined';
        this.lastBackupStatus = 'Not determined';
        this.nextBackup = 'Not determined';
        this.serverTimeZone='';
        this.serverTime='';
        this.secretKey='';
    }
});

function setBackupSchedule(form) {
    var backupScheduleInfo = new BackupScheduleInfo();
    var errors = [];
    backupScheduleInfo.enabled = Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').size() != 0 ? (Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').find(function (radio) { return radio.checked; }) != null ? (Form.getInputs('frmBackupSchedule', 'radio', 'enabled_state').find(function (radio) { return radio.checked; }).value == 'Enabled' ? true : false) : false) : false;

    var days = Form.getInputs('frmBackupSchedule', 'checkbox', 'days[]');

    // checkbox tests for validation
    var atleastOneChecked = false;
    days.each(function(el){
        if( el.checked ){ atleastOneChecked = true; }
    })

    // timeOfBackup form field validation
    var timeOfBackup = $('timeOfBackup').value;
    var timeOfBackupIsValid = true;
    if(timeOfBackup == '' || timeOfBackup == "HH:mm" || timeOfBackup == "Not configured" || timeOfBackup == "Not Configured"){
        timeOfBackupIsValid = false;
    }

    if(atleastOneChecked && timeOfBackupIsValid){
        backupScheduleInfo.sunday = days[0] ? days[0].checked : false;
        backupScheduleInfo.monday = days[1] ? days[1].checked : false;
        backupScheduleInfo.tuesday = days[2] ? days[2].checked : false;
        backupScheduleInfo.wednesday = days[3] ? days[3].checked : false;
        backupScheduleInfo.thursday = days[4] ? days[4].checked : false;
        backupScheduleInfo.friday = days[5] ? days[5].checked : false;
        backupScheduleInfo.saturday = days[6] ? days[6].checked : false;
        if ($('timeOfBackup').value == 'Not configured') {
            backupScheduleInfo.timeOfBackup = '';
        }
        else {
            backupScheduleInfo.timeOfBackup = $('timeOfBackup').value;
        }
		backupScheduleInfo.secretKey =  getSecretKey();
        new Ajax.Request(urlConfig.setBackupSchedule, { parameters: backupScheduleInfo,
            method: 'post',
            onSuccess: function (transport) { setBackupScheduleJSONResponse(transport.responseText) },
            onFailure: function (transport) { setBackupScheduleJSONResponse(transport.responseText) }
        });
    }else{
        if(!atleastOneChecked){
            errors.push("Atleast one day must be checked for backup");
        }
        if(!timeOfBackupIsValid){
            errors.push("You must enter a time of backup in the valid 24 hour time format (HH:mm)")
        }

        // show the errors
        var stringList = '<p>';
        errors.each(function(err){ // display each error
            stringList += err+'<br />';
        })
        stringList += '</p>';
        var localMsgArea   = $('section_31_0_messages');
        var localTmpId = localMsgArea.readAttribute('id')  + '_' + (Math.floor(Math.random() * 10000));
        localMsgArea.update().insert({bottom: '<div id="' + localTmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' +stringList+ '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + localTmpId + '\');"></div><div style="clear:both;"></div></div>'});
    }

    if(errors.length > 0){
        return false;
    }

}

function setBackupScheduleJSONResponse(backupScheduleResponse) {
    var JobErrorResponse = backupScheduleResponse.evalJSON(true).BackupScheduleResponse;
    var sectionId = 'section_31_0';
    var contentBlockDivId = 'block_section_31_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
        	onLoadBackupPage();
            // Insert new Success message box at bottom of existing message boxes.
            $(sectionMessagesId).update().insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            if ($('days').innerHTML == '') {
                $('days').innerHTML = 'None';
            }
            cacheSectionForTogglingEditMode.toggle();
        }
        else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            //$(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            $(sectionMessagesId).update().insert({bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' +msgText+ '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div><div style="clear:both;"></div></div>'});

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
}

//Alert Management

function displayAlert(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.AlertInfo) {
        var alertData = data.AlertInfo;
        $('number_of_alerts').innerHTML = alertData.currentNumber.length == 0 ? '0' : alertData.currentNumber;
        $('maxAlerts').innerHTML = alertData.maxNumber.length == 0 ? 'Not configured' : alertData.maxNumber;
        $('daysToRetain').innerHTML = alertData.daysToRetain.length == 0 ? 'Not configured' : alertData.daysToRetain;
        $('timeoutForDuplicates').innerHTML = alertData.timeOutForDuplicates.length == 0 ? 'Not configured' : alertData.timeOutForDuplicates;
    }
}

var AlertInfo = Class.create({
    initialize: function () {
        this.currentNumber = 0;
        this.maxNumber = 0;
        this.daysToRetain = 0;
        this.timeOutForDuplicates = 0;
        this.rowsToClean = 0;
        this.cleanUpInterval=60000;
        this.secretKey = '';
    }
});

function setAlert(form) {
    var alertInfo = new AlertInfo();
    if ($('max_of_alerts').value == 'Not configured') {
        alertInfo.maxNumber = '';
    }
    else {
    alertInfo.maxNumber = $('max_of_alerts').value;
    }
    if ($('days_to_retain').value == 'Not configured') {
        alertInfo.daysToRetain = '';
    }
    else {
    alertInfo.daysToRetain = $('days_to_retain').value;
    }
    if ($('timeout_for_duplicates').value == 'Not configured') {
        alertInfo.timeOutForDuplicates = '';
    }
    else {
    alertInfo.timeOutForDuplicates = $('timeout_for_duplicates').value;
    }
	alertInfo.secretKey =  getSecretKey();
	new Ajax.Request(urlConfig.setAlert, { parameters: alertInfo,
        method: 'post',
        onSuccess: function (transport) { setAlertJSONResponse(transport.responseText) },
        onFailure: function (transport) { setAlertJSONResponse(transport.responseText) }
    });
}

function setAlertJSONResponse(alertResponse) {
    var JobErrorResponse = alertResponse.evalJSON(true).AlertResponse;
    var sectionId = 'section_4_0';
    var contentBlockDivId = 'block_section_4_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
        else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
}

// Change Admin Password

var PasswordInfo = Class.create({
    initialize: function () {
        this.currentPassword = '';
        this.newPassword = '';
        this.vNewPassword = '';
    }
});

function changeAdminPassword() {
    // Hide any old Success message using a blind up effect.
    $('section_9_0_messages').select('div.msgSuccess').each(function (item) { item.blindUp(); });
    $('section_9_0_messages').select('div.msgFailure').each(function (item) { item.blindUp(); });

    var passwordInfo = new PasswordInfo();
    passwordInfo.currentPassword = $('current_password').value;
    passwordInfo.newPassword = $('new_password').value;
    passwordInfo.vNewPassword = $('verify_new_password').value;

    // Reset the form fields to blank.
    $('current_password').value = '';
    $('new_password').value = '';
    $('verify_new_password').value = '';
    
    new Ajax.Request(urlConfig.changePassword, { parameters: passwordInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setPasswordJSONResponse(transport.responseText) },
        onFailure: function (transport) { setPasswordJSONResponse(transport.responseText) }
    });
}

function setPasswordJSONResponse(passwordResponse) {
    var JobErrorResponse = passwordResponse.evalJSON(true).PasswordResponse;
    var sectionId = 'section_9_0';
    var contentBlockDivId = 'block_section_9_0_0_0';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
        // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Set one of SimpleForm's properties with the content block's inner HTML.
            setSimpleFormContentBlock(contentBlockDivId);
        }
        else {
            // Hide messages. Insert new Failed message box at bottom of existing message boxes.
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }
    }
}
var NetworkInfo = Class.create({
    initialize: function () {
	this.hostName = "localhost";
	this.ipAddress="";
	this.subnetMask="";
	this.primaryDNS="";
	this.secondaryDNS="";
	this.defaultGateway="";
	this.ntpServer="";
    }
});

function displayNetworkInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.NetworkInfo) {
        var netInfo = data.NetworkInfo;
        $('host_name').innerHTML =  netInfo.hostName;
        $('tcp_ip_address').innerHTML = netInfo.ipAddress;
        $('subnet_mask').innerHTML = netInfo.subnetMask;
//        $('default_gateway').innerHTML = netInfo.defaultGateway;
        $('primary_dns').innerHTML = netInfo.primaryDNS;
        $('secondary_dns').innerHTML = netInfo.secondaryDNS;
        
    }
}

var EncryptionPasswordInfo = Class.create({
    initialize: function () {
        this.password = '';
        this.vPassword = '';
    }
});


function setEncryptionPassword(form) {
	
    var passwordInfo = new EncryptionPasswordInfo();
    
    passwordInfo.password = $('encpassword').value;
    passwordInfo.vPassword = $('vencpassword').value;

    new Ajax.Request(urlConfig.setEncryptionPassword, { parameters: passwordInfo,
        method: urlConfig.postMethod,
        onSuccess: function (transport) { setEncryptionPasswordJSONResponse(transport.responseText) },
        onFailure: function (transport) { setEncryptionPasswordJSONResponse(transport.responseText) }
    });
}

function setEncryptionPasswordJSONResponse(encryptionPasswordResponse) {
    var JobErrorResponse = encryptionPasswordResponse.evalJSON(true).EncryptionPasswordResponse;
    var sectionId = 'section_32_0';
    var contentBlockDivId = 'block_section_32_0_0_1';
    var sectionMessagesId = sectionId + '_messages';
    if ($(sectionMessagesId)) {
         // Generate a unique id.
        var tmpId = Math.floor(Math.random() * 10000);
        tmpId = sectionMessagesId + '_' + tmpId;

        var msgText = JobErrorResponse.errorMessage;

        if (JobErrorResponse.responseCode == 0) {
            // Insert new Success message box at bottom of existing message boxes.
            
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });

            // Hide (display: none) the Password table row.
            if ($('encpassword')) {
                if ($('encpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('encpassword').up('tr').addClassName('hidden');
                    
                }
                $('encpassword').innerHTML = '';
            }

            // Hide (display: none) the Verify Password table row.
            if ($('vencpassword')) {
                if ($('vencpassword').up('tr')) {
                    // Unhide the Verify Password table row.
                    $('vencpassword').up('tr').addClassName('hidden');
                }
                $('vencpassword').innerHTML='';
                
            }
            
        }
        else {
            // Hide any old Start or Failure message using a blind up effect.
            $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.blindUp(); });
            $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
            // Reset the values in the form to the unedited values.
            getSimpleFormContentBlock(contentBlockDivId);
        }


    }
}

function displayEncryptionPassword(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.EncryptionPasswordInfo) {
        var passwordInfo = data.EncryptionPasswordInfo;
        $('encpassword').innerHTML =  passwordInfo.password;
        $('vencpassword').innerHTML =  passwordInfo.vPassword;
     
    }
}



var ApplianceCertificateInfo = Class.create({
    initialize: function () {
		this.issuedTo;
		this.issuedBy;
		this.validFrom;    
	}
});

function displayApplianceCertificateInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ApplianceCertificateInfo) {
        var info = data.ApplianceCertificateInfo;
        $('issued_by').innerHTML =  info.issuedBy;
        $('issued_to').innerHTML =  info.issuedTo;
        $('valid_from').innerHTML =  info.validFrom;
     
    }
}

function displayTarball(transport) {
	//alert('displayTarball: ' + transport.responseText);
	var JobErrorResponse = transport.responseText.evalJSON(true).GetTarballResponse;
	if (JobErrorResponse.responseCode == 0) 
	{
		var msg = 'Click the following link to download the troubleshooting bundle<p><p><a ' +
			'class=\"modalIconLink\"' + 'href="' 
			+ JobErrorResponse.errorMessage + '">Download Troubleshooting Bundle</a>';
		displayModalResult(msg, 'Close', 'statusLargeSuccessIcon');
	}
	else
	{
		displayModalResult(JobErrorResponse.errorMessage, 'Close', 'statusLargeCriticalIcon');
	}
}


function displayModalResult(messageContent, buttonName, iconType)
{
    var selector = $('update_status');
    var checkbox = document.createElement('div');
    selector.innerHTML = messageContent;
    checkbox.setAttribute('class','statusLargeIcon ' + iconType);
    Element.replace( $('update_status_icon'), checkbox);
    
    //$('block_section_modalContent_0_0_0').insert({ bottom: messageContent });
	$('tarball_button').innerHTML = buttonName;
}

var LicenseInfo = Class.create({
    initialize: function () {
	this.maxVCenters = "0";
	this.maxHosts = "0";
	this.vCentersUsed = "0";
	this.vCentersRemaining = "0";
	this.hostsUsed = "0";
	this.hostsRemaining = "0";
	this.hostsUnlicensed = "0";
	}
});

function displayLicenseInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.LicenseInfo) {
    	
    	//Hide all the informaion and warning messages so that they appear later based on the license state.
    	$('unlicensedHostsRow').hide();
    	$('hostLicenseWarning').hide();
    	$('hostLicenseNoRemaining').hide();
    	
        var info = data.LicenseInfo;
        $('maxVCenters').innerHTML =  info.maxVCenters;
        $('maxHosts').innerHTML =  info.maxHosts;
        $('vCentersUsed').innerHTML =  info.vCentersUsed;
        $('vCentersRemaining').innerHTML =  info.vCentersRemaining;
        $('hostsUsed').innerHTML =  info.hostsUsed;
        //If the host license is unlimited, then don't check anything else.
        if(info.maxHosts == 'Unlimited'){
            $('hostsRemaining').up('tr').addClassName('hidden');
        }
        //If the license is not unlimited
        else{
            $('hostsRemaining').up('tr').removeClassName('hidden');
            $('hostsRemaining').innerHTML = info.hostsRemaining;
            var iHostsUsed = parseInt(info.hostsUsed);
        	var iMaxHosts = parseInt(info.maxHosts);
            if(iHostsUsed > iMaxHosts){
            	$('unlicensedHosts').innerHTML = iHostsUsed - iMaxHosts;
            	$('unlicensedHostsRow').show();
            	$('hostLicenseWarning').show();
            }
            else if(iHostsUsed == iMaxHosts){
            	$('hostLicenseNoRemaining').show();
            }
        }
        if(info.vCentersUsed == info.maxVCenters){
            $('vCenterLicenseInfo').show();
        }

    }
}

function onVCenterPageLoad(){
	new Ajax.Request(urlConfig.getLicenseInfo, { method: 'get',
    	onComplete: function (transport) {
      	  displayLicenseInfo(transport);
    	}
	});
	new Ajax.Request(urlConfig.getVCenters, { method: 'get',
        onComplete: function (transport) {
            displayVCenters(transport);
        }
    });
}

var ApplianceUpdate = Class.create({
    initialize: function () {
	this.repositoryPath = "Not determined";
	this.currentVersion = "Not determined";
	this.availableVersion = "Not determined";
	this.upgradePossible=false;
	this.defaultURL = "Not determined";
	 
	}
});

function displayApplianceUpdateInfo(transport) {
    var data = transport.responseText.evalJSON(true);
    if (data.ApplianceUpdate) {
        var info = data.ApplianceUpdate;
        $('current_appliance_version').innerHTML =  info.currentVersion;
        $('available_appliance_version').innerHTML =  info.availableVersion;
        $('repositoryPath').innerHTML =  info.repositoryPath;
        $('upgradePossible').value = info.upgradePossible;
        $('defaultURL').innerHTML =  info.defaultURL;
    }
}

var NetworkShareInfo = Class.create({
    initialize: function () {
		this.share = "";
		this.user = "";
		this.password = "";
		this.folder=true;
	}
});

function restoreCertificate() {
    // Disable Cancel and Apply buttons; the Apply button is actually rendered first even though it is shown on the right.
    $('section_modalContent_0').select('.sectionEditButtons button').each(function (item) {
        item.disabled = true;
        item.removeClassName('stdButtonEmphasized1');
        item.addClassName('stdButtonDisabled');
    });
    
	enableProcessingInModal("Please wait...");
    
	try
	{

	    new Ajax.Request(urlConfig.restoreCertificate, {parameters:  getSecretKey(), method: urlConfig.postMethod,
	        onSuccess: function (transport) { 
                setGenericJSONResponse('section_5_0', transport.responseText) },
            onFailure: function (transport) { 
                setGenericJSONResponse('section_5_0', transport.responseText) }
	    });
	}
	catch(ex)
	{
		handleModalException(ex);
	}
}

function handleModalException(ex)
{
	var msg = 'The following error occurred when communicating with Dell Plugin, please try it again later' + 
	', Error Name:' + e.name + ', Error Message:' + e.message; 
	$('modalContent').innerHTML = msg;
}

function setGenericJSONResponse(sectionId, virtualApplianceActionResponse) {
    var JobErrorResponse = virtualApplianceActionResponse.evalJSON(true).VirtualApplianceActionResponse;
    var sectionMessagesId;
    // Generate a unique id.
    var tmpId = Math.floor(Math.random() * 10000);
    var msgText = JobErrorResponse.errorMessage;

    if (JobErrorResponse.responseCode == 0) {
        closeModal();
        // Insert new Success message box at bottom of existing message boxes.
        sectionMessagesId = sectionId + '_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgSuccess"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Success</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
    else {
        // Hide messages. Insert new Failed message box at bottom of existing message boxes in the modal window.
        enableEditButtonsAndHideMsg('section_modalContent_0');
        sectionMessagesId = 'section_modalContent_0_messages';
        tmpId = sectionMessagesId +'_'+ tmpId;
        if ($(sectionMessagesId)) {
            $(sectionMessagesId).insert({ bottom: '<div id="' + tmpId + '" class="msgBox msgFailure"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Failed</div></td><td class="maxWidthCol"><div class="msgText">' + msgText + '</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'' + tmpId + '\');"></div></div>' });
        }
    }
}

function showStartMsg(sectionId) {
    var sectionMessagesId = sectionId + '_messages';

    // Hide any old Failure or Success message using a blind up effect.
    $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function (item) { item.blindUp(); });

    // Display only one (generic) Starting message.
    if ($(sectionMessagesId).down('div#divMsgStarting', 0)) {
        $(sectionMessagesId).select('div#divMsgStarting').each(function (item) { item.setStyle({ display: '' }) });
    }
    else {
        $(sectionMessagesId).insert({ bottom: '<div id="divMsgStarting" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Processing</div></td><td class="maxWidthCol"><div class="msgText">Please wait.....</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'divMsgStarting\');"></div></div>' });
    }
}

var NtpSettings = Class.create({
    initialize: function () {
		this.enabled;
		this.ntpPreferred;
		this.ntpSecondary;    
	}
});

function displayNtpSettings(transport){
    var data = transport.responseText.evalJSON(true);
    // Hide any old Failure or Success message using a blind up effect.
    var sectionMessagesId = 'section_3_0_messages';
    $(sectionMessagesId).select('div.msgFailure').each(function (item) { item.blindUp(); });
    $(sectionMessagesId).select('div.msgSuccess').each(function (item) { item.blindUp(); });
    
    if (data.NtpSettings) {
        var settings = data.NtpSettings;
        $('enabled').innerHTML = settings.enabled == true ? 'Enabled' : 'Disabled';
        var ntpStandard = $('ntp_standard');
        if(settings.enabled){
            var tmpId   = '_' + (Math.floor(Math.random() * 10000));
            if(ntpStandard)
            	ntpStandard.innerHTML = '<div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Info.</div></td><td class="maxWidthCol"><div class="msgText">VMware tools time sync option is disabled because NTP is enabled.</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'ntp_standard\');"></div></div>';
            else            
            $('section_3_0_messages').insert({bottom: '<div id="ntp_standard" class="msgBox msgInfo"><div class="msgIcon"></div><div class="msgContent"><table class="msgTable"><tr><td><div class="msgTitle">Info.</div></td><td class="maxWidthCol"><div class="msgText">VMware tools time sync option is disabled because NTP is enabled.</div></td></tr></table></div><div class="msgCloseButton" onclick="closeMsgBox(\'ntp_standard\');"></div></div>'});
        }
        else 
        {
        	if(ntpStandard)
        		ntpStandard.remove();
        }
        
        if(settings.ntpPreferred != ''){
            $('ntpPreferred').innerHTML = settings.ntpPreferred;
        }

        if(settings.ntpSecondary != ''){
            $('ntpSecondary').innerHTML = settings.ntpSecondary;
        }
    }
}

function displayBackupSettings(transport){
    var data = transport.responseText.evalJSON(true);
    if(data.BackupSettings){
        var settings = data.BackupSettings;
        $('backupLocation').innerHTML = settings.backupLocation;
        $('userName').innerHTML = settings.userName;
    }
}

function onLoadBackupPage(){
	
	$$('.sectionEditButton').each(function (item) {item.addClassName('disabled');});
	
	 new Ajax.Request(urlConfig.getBackupSettings, {  method: 'get', asynchronous:false,
		onComplete: function (transport) {
			displayBackupSettings(transport);
		}
	 });

	 new Ajax.Request(urlConfig.getBackupSchedule, {  method: 'get', asynchronous:false,
	        onComplete: function (transport) {
	            displayBackupSchedule(transport);
	        }
	 });
	 $$('.sectionEditButton').each(function (item) {item.removeClassName('disabled');});
}
function displayCurrentVersion(transport){
    var data = transport.responseText.evalJSON(true);
    	if(data.ApplianceUpdate){
    		var versionData = data.ApplianceUpdate;
    		var version = versionData.currentVersion;
    		var build = "Not determined";
    		var index = version.lastIndexOf(".");
    		build = version.substring(index+1);
    		version = version.substring(0,index);
    		$('version').innerHTML = version;
    		$('build').innerHTML = build;
        }
}

function buildTimeZoneDesignation( ){
	var date = new Date();
	var timeZoneAsString = "GMT";
	var offset = date.getTimezoneOffset();
	if ( (offset / 60 > 0) && (offset / 60 < 10) ) {
		timeZoneAsString = timeZoneAsString + "-" + ( offset / 60 );
	} else if ( (offset < 0) && (offset / 60 > -10) ) {
		timeZoneAsString = timeZoneAsString + "+" + ( -1 * offset / 60 );
	}
	return timeZoneAsString;

}

function refreshApplianceUpdateInfo(){
	new Ajax.Request(urlConfig.getApplianceUpdateInfo, { method: 'get',asynchronous:false,
    	onComplete: function (transport) {
    		displayApplianceUpdateInfo(transport);
    	}
    });    
}

function enableProcessingInModal(message) {
	$('block_section_modalContent_0_0_0').innerHTML ='<div id="divNewMsgStarting"><div style="float:left;margin:15px 35px;"><img id="update_status_icon" src="images/loading_icon.gif" alt="" /></div><div id="update_status" style="float:left;margin:20px 0;width:200px;">'+message+'</div></div>';
}

function submitLogout(){
 	window.location.href = "j_spring_security_logout"; 
}
function clearTestConnectionResult(){
    $('val_icn_app_update').removeClassName('val-fail');
    $('val_icn_app_update').removeClassName('val-success');
    $('val_icn_app_update').removeClassName('val-waiting');
    $('val_msg_app_update').innerHTML = '';
}
function clearBackupSettingsPassword(){
	$('backupLocationPassword').innerHTML = "";
	$('encryptionPassword').innerHTML = "";
	$('encryptionVPassword').innerHTML = "";
}

function clearBackupSettingsForm(){
	//$('backupLocation').innerHTML = "Not Configured";
	//$('userName').innerHTML = "Not Configured";
	 new Ajax.Request(urlConfig.getBackupSettings, {  method: 'get',
			onComplete: function (transport) {
				displayBackupSettings(transport);
			}
	 });
}
function onLoadAppliancePage(){
	
	$$('.sectionEditButton').each(function (item) {item.addClassName('disabled');});

    refreshApplianceUpdateInfo();
    
    new Ajax.Request(urlConfig.getNetworkInfo, { method: 'get',asynchronous:false,
    	onComplete: function (transport) {
            displayNetworkInfo(transport);
    	}
    });

    new Ajax.Request(urlConfig.getApplianceCertificateInfo, { method: 'get',asynchronous:false,
    	onComplete: function (transport) {
            displayApplianceCertificateInfo(transport);
    	}
    });

    new Ajax.Request(urlConfig.getNtpSettings, { method: 'get',asynchronous:false,
    	onComplete: function (transport) {
    	displayNtpSettings(transport);
    	}
    });

   $$('.sectionEditButton').each(function (item) {item.removeClassName('disabled');});

}
function onLoadAlertsPage(){
	
	$$('.sectionEditButton').each(function (item) {item.addClassName('disabled');});
	
	new Ajax.Request(urlConfig.getAlert, { method: 'get', asynchronous:false,
		onComplete: function (transport) {
		displayAlert(transport);
		}
		});
	
	$$('.sectionEditButton').each(function (item) {item.removeClassName('disabled');});
}
function checkForSecurityAndLogout(strMsg){
	
	if(strMsg.match('AdminPortalSecurityException')){
		 alert("The Web request authorization failed; click OK to log out and retry with a new session");
		 window.location.href = "j_spring_security_logout";
	}
}
function getSecretKey(){
	// @CSRF
    if( !$.sessionizer.isAvailable() ){
       return $('fldSecretKey').value;
    }else{
        return $.sessionizer.get('secretKey');
    }
}
