var uploader = new qq.FileUploader({
  element: $('uploadLicensingFile'),
  action: 'go',
  onSubmit: function (id, fileName) {
	$('txtLicenseFilePath').value = fileName;
	VIS.Ajax.clearErrorMessages();
  },
  onComplete: function (id, fileName, responseJSON) {
	if (responseJSON.success) {
	  VIS.Forms.resetAllNotifications();
	  setupAndConfiguration.licensingLicenseFileUploaded(responseJSON.id, fileName, responseJSON);
	  var notification = new VIS.Notification('Info', null, 'File successfully uploaded.');
	  VIS.UI.Notifications.push(notification);
	  VIS.Forms.renderNotifications();
	}
  },
  showMessage: function (message) {
	VIS.Forms.resetAllNotifications();

	var error = new VIS.Error('Error', null, "File Uploader Has Failed");
	error.fldErrors = [{ errorMessage: message, field: "txtLicenseFilePath"}];
	VIS.UI.Errors.push(error);

	if (VIS.UI.Errors.length > 0) {
	  VIS.Ajax.renderErrors();
	}
  }
});

var setupAndConfiguration = {
	licensingLicenseFileUploaded: function (id, fileName, responseJSON) {
    if (responseJSON.success) {
      // alert("The file, " + fileName + ", was successfully uploaded");
      if (typeof (responseJSON.id) != "undefined")
        id = responseJSON.id;
    }
    if (setupAndConfiguration.item.LicenseFile == null) {
      var LicenseFile = new Object();
      LicenseFile.ID = id;
      LicenseFile.Path = fileName;
      LicenseFile.Name = fileName;
      setupAndConfiguration.item.LicenseFile = LicenseFile;
    }
    else {
      setupAndConfiguration.item.LicenseFile.ID = id;
      setupAndConfiguration.item.LicenseFile.Path = fileName;
      setupAndConfiguration.item.LicenseFile.Name = fileName;
    }
  }
}