<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title><fmt:message key="application.name" /></title>
   <link href="styles/global.css" media="screen,print" rel="stylesheet" type="text/css" />
    
    <!--[if lt IE 8.]>
	<link href="styles/global.ie7.css" rel="stylesheet" type="text/css" />
	<![endif]-->
    
    <!--[if gte IE 8]>
	<link href="styles/global.ie8.css" rel="stylesheet" type="text/css" />
	<![endif]-->
    
    <!-- prevents somewhat flickering issue when changing pages in IE -->
    <!--[if IE]>
	<meta http-equiv="Page-Exit" content="Alpha(opacity=100)" />
	<![endif]-->
    
    <link href="custom/styles/custom.css" media="screen,print" rel="stylesheet" type="text/css" />
    
    <script src="scripts/libraries/prototype.js" type="text/javascript"></script>
    <script src="scripts/libraries/scriptaculous/scriptaculous.js" type="text/javascript"></script>    
    <script src="scripts/libraries/prototypextensions.js" type="text/javascript"></script>    
    
    <!-- sort table library - customized to match site specific tables -->
    <script src="scripts/libraries/sorttable.js" type="text/javascript"></script>
    
    <!-- url.js object needs to be initialized before global.js can make a call 
    to the backend to get browser language -->
    <script src="config/url.js" type="text/javascript"></script>
    
    <script src="scripts/global.js" type="text/javascript"></script>
    <script src="scripts/navigation.js" type="text/javascript"></script>
    <script src="scripts/login.js" type="text/javascript"></script>    
    <script src="scripts/index.js" type="text/javascript"></script>    
    <script src="custom/scripts/custom.js" type="text/javascript"></script>
	<script src="scripts/sessionizer.js" type="text/javascript"></script>
    <script type="text/javascript" src="custom/scripts/v1.1_additions.js"></script>
    <script type="text/javascript">
    
        //This overrides the default index.xml for the tree structure.
        //This should be changed to a REST address the returns a XML from the webserver.
        var navigationconfigfile = 'config/menu.xml';
        onLoadIndexPage();
   </script>
</head>
<body>
    <div id="main">
        <div id="header">
        </div>
        <div id="masthead">
            <div id="mastheadLogos" class="floatLeft">
                <a href="#">
                    <span id="mastheadDellLogo">
                    </span>
                </a><a href="#">
                    <span id="mastheadAppLogo">
                    </span>
                </a>
            </div>
            <!--<img id="mastheadAppTitle" src="images/logos/spectre.png" alt="Administration Portal" />-->
			<div id="mastheadAppTitle"><fmt:message key="application.name" /></div>
            <div id="mastheadUtilityNav" class="floatRight">
                <a href="j_spring_security_logout"><fmt:message key="index.logout" /></a>
            </div>
        </div>
        <div id="bodyTop">
        </div>
        <div id="innerBody">
            <div id="mainNav" class="floatLeft">
            </div>
            <div id="mainContent" class="floatLeft">
                <!-- Take the below line out for non Microsoft MVC projects-->
                <asp:ContentPlaceHolder ID="content" runat="server" />
            </div>
        <div class="clear">
        </div>
    </div>
    <div id="bodyBottom">
    </div>
    <div id="footer">
        <div class="floatRight">
            <a href="#"><span id="footerDellLogo"></span></a>
        </div>
        <div id="footerNav" class="floatRight" style="padding-top:11px">
            <a href="#" onclick="openModalAndCloseSectionMessage(urlConfig.viewAboutModal, 'halfWidth', 0);"><fmt:message key="generic.about" /></a>
        </div>
    </div>
    </div>
    <!-- start : modal overlay -->
    <!--
	notes:  
		- special classes are added to the #modalOverlay, and all classes are cleared when closed
	-->
    <div id="modalOverlay" style="display: none; height: 100%">
        <div id="modalOuterContainer">
            <div id="modalInnerContainer">
            	<!-- start : modal overlay utility nav -->
            	<div id="modalUtilNav">
            		<div class="modalUtilNavOuter">
						<div class="modalUtilNavInner">
							<!--div class="modalUtilNavItem modalUtilNavHelp" onclick="showHelp();"></div>
							<div class="modalUtilNavDiv"></div-->
							<div class="modalUtilNavItem modalUtilNavClose" onclick="closeModal();"></div>
						</div>
					</div>
                </div>
                <!-- end : modal overlay utility nav -->
                
                <!-- start : modal overlay content -->
                <!--
				notes:  
					- update div to contain specified modal popup window content
				-->
                <div class="modalInnerTop"></div>
                
                <div id="modalContent"></div>
                
                <div class="modalInnerBottom"></div>
                <!-- end : modal overlay content -->
                
                <!-- start : modal overlay scrollbar -->
                <div id="modalScrollbarContainer" class="scrollBarContainerVertical" style="display: none;">
                    <div class="scrollBarTrackVerticalBottom"> </div>
                    <div id="modalScrollbarTrack" class="scrollBarTrackVertical">
                        <div id="modalScrollbarHandle" class="scrollBarHandle"></div>
                    </div>
                </div>
                <!-- end : modal overlay scrollbar -->
            </div>
        </div>
    </div>
    <!-- end : modal overlay -->

    <!-- @CSRF -->
    <input type="hidden" value="" name="secretKey" id="fldSecretKey" style="behavior:url('#default#userdata')" />
    <script type="text/javascript">
        if( !$.sessionizer.isAvailable() ){
            var _elm = $('fldSecretKey');

            window.onload = function(){
                if(_elm.addBehavior){
                    _elm.load("secretkeypersist");
                    if(_elm.getAttribute("secretkeyattribute")){
                        _elm.value = _elm.getAttribute("secretkeyattribute");
                        _elm.removeAttribute("secretkeyattribute");
                        _elm.save("secretkeypersist");
                    }
                }
            }

            // detect refresh
            var leaving = false;
            var confirmExit = function(){
                if(_elm.addBehavior){
                    _elm.load("secretkeypersist");
                    _elm.setAttribute("secretkeyattribute", _elm.value );
                    _elm.save("secretkeypersist");
                }
            }
            window.onbeforeunload = confirmExit;
        }
        
    </script>

</body>
</html>
