﻿


//For cookies
var cookies = {
    getCookie: function (c_name) {
        if (document.cookie.length > 0) {
            c_start = document.cookie.indexOf(c_name + "=")
            if (c_start != -1) {
                c_start = c_start + c_name.length + 1
                c_end = document.cookie.indexOf(";", c_start)
                if (c_end == -1) c_end = document.cookie.length
                return unescape(document.cookie.substring(c_start, c_end))
            }
        }
        return ""
    },
    setCookie: function (c_name, value, expiredays) {
        var exdate = new Date()
        exdate.setDate(exdate.getDate() + expiredays)
        document.cookie = c_name + "=" + escape(value) +
  ((expiredays == null) ? "" : "; expires=" + exdate.toGMTString())
    }
};

var LoginInfo = Class.create({
    initialize: function (loginname, password) {
        this.UserName = loginname;
        this.Password = password;
    }
});


//For Login
var postLogin = {
    timer: null,
    posted: null,
    post: function () {
        //turn on verify
        $('loginContainer').addClassName('loginVerify');
        var logindata = new LoginInfo($('username').value, $('password').value);
        new Ajax.JSON(urlConfig.loginPost, {
            method: urlConfig.postMethod,
            object: logindata,
            onSuccess: function (transport) { postLogin.success(transport.responseText) }
        });
        postLogin.posted = true;
        loginHelper.writeCookies();
        return false;
    },
    success: function (obj) {
        //check if post was cancelled
        if (postLogin.posted == true) {
            postLogin.posted == false;
            //check responseCode and send to url if 0
            var LoginResponse = obj.evalJSON(true).LoginResponse;
            if (LoginResponse.responseCode == 0) {
                document.location.href = LoginResponse.URL;
            } else {
                postLogin.failed(LoginResponse);
            }
        }
    },
    failed: function (obj) {
        //fill in error title and message with response
        $('loginErrorTitle').innerHTML = obj.responseTitle;
        $('loginErrorMessage').innerHTML = obj.responseMessage;
        //turn off verify
        $('loginContainer').removeClassName('loginVerify');
        //turn on failed
        $('loginContainer').addClassName('loginError');
        //add timer for calling tryagain after 15 seconds or so
        postLogin.timer = postLogin.tryAgain.delay(15);
    },
    tryAgain: function () {
        $('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
        loginHelper.getCookies.delay(1);
        loginHelper.clearPassword.delay(1);
        return false;
    },
    cancel: function () {
        //clear fields
        $('loginContainer').removeClassName('loginVerify');
        $('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
        loginHelper.getCookies.delay(1);
        loginHelper.clearPassword.delay(1);
        postLogin.posted = false;
    },
    toggleDomain: function (obj) {
        if (obj.value == 1) {
            $('domainText').show();
            $('domain').show();
        } else {
            $('domainText').hide();
            $('domain').hide();
        }
    }
};
var loginHelper = {
    loginmethod: null,
    getCookies: function () {
        var uname = cookies.getCookie('username');
        var domain = cookies.getCookie('domain');
        loginHelper.loginmethod = cookies.getCookie('loginmethod');
        if (uname != '') {
            $('loginName').value = uname;
            if ($('domain') != null) {
                $('domain').value = domain;
            }
            Form.getInputs('loginForm', 'radio', 'loginmethod').find(function (radio) { if (radio.value == loginHelper.loginmethod) { radio.checked = true; postLogin.toggleDomain(radio); } });
            $('rememberme').checked = true;
            loginHelper.clearPassword();
        } else {
            $('loginName').focus();
        }

    },
    writeCookies: function () {
        if ($('rememberme').checked == true) {
            var uname = $('loginName').value;
            cookies.setCookie('username', uname, 365);
            var domain = $('domain') != null ? $('domain').value : '';
            var loginmethod = Form.getInputs('loginForm', 'radio', 'loginmethod').size() != 0 ? Form.getInputs('loginForm', 'radio', 'loginmethod').find(function (radio) { return radio.checked; }).value : '';
            if (domain != '') {
                cookies.setCookie('domain', domain, 365);
            }
            if (loginmethod != '') {
                cookies.setCookie('loginmethod', loginmethod, 365);
            }
        } else {
            this.clearCookies();
        }
    },
    clearCookies: function () {
        cookies.setCookie('username', '', -1);
        cookies.setCookie('domain', '', -1);
        cookies.setCookie('loginmethod', '', -1);
    },
    clearPassword: function () {
        try {
            if ($('password').visible) {
                $('password').value = '';
                $('password').focus();
            }
        }
        catch (e) {
        }
    }
};




//For Logout
var postLogout = {
    post: function () {
        new Ajax.Request(urlConfig.logoutPost, {
            method: urlConfig.postMethod,
            onSuccess: function (transport) { postLogout.success(transport.responseText) }
        });

        return false;
    },
    success: function (obj) {
        var LogoutResponse = obj.evalJSON(true);
        if (LogoutResponse.responseCode == 0) {
            document.location.href = LogoutResponse.URL;
        } else {
            postLogout.failed(LogoutResponse);
        }
    },
    failed: function (obj) {
        //not sure what to do if this fails
    }
};

