﻿var tree = {
	firstNode: null,

	createStdAnchor: function (text, url) {
		var anchor = new Element('a')

		anchor.appendChild(document.createTextNode(text));
		anchor.setAttribute('href', 'javascript:checkSession("","");');
		anchor.setAttribute('URL', url);

		return anchor;
	},

	writeTree: function (nodes) {

		var attribs, index, li, anchor;

		var nav = $('mainNav');

		var j = 0;

		var ul = new Element('ul');
		ul.addClassName('topMainNav');

		for (var i = 0; i < nodes.length; i++) {
			if (nodes[i].nodeName == "Tree") {
				attribs = this.getAttributes(nodes[i]);
				index = 'T' + j;
				li = new Element('li');

				var currentTitleProp = this.getAttribute(attribs[0]);
				var currentTitle = Translator.translate(currentTitleProp);

				anchor = this.createStdAnchor(currentTitle, this.getAttribute(attribs[1]));

				anchor.setAttribute('index', index);

				anchor.id = index + '-LINK';

				Event.observe(anchor, 'click', function () { navigation.clickTree(this); });

				if (j == 0) {
					tree.firstNode = anchor;
				}

				li.appendChild(anchor);
				ul.appendChild(li);
				li = tree.writeBranches(index, nodes[i], anchor);

				if (li) {
					s = new Element('span');
					s.addClassName('primaryNavWithSubs');
					anchor.appendChild(s);

					ul.appendChild(li);
				}


				j++;
			}
		}

		nav.appendChild(ul);
	},

	writeBranches: function (tindex, nodes, anchor) {
		var attribs, ili, ia, li, index, l, s;
		var j = 0;
		var branch = tree.getChildNodes(nodes);
		if (branch != null) {
			li = new Element('li');

			li.addClassName('mainNavSecondaryContainer');
			li.setStyle({ display: 'none' });

			li.id = tindex;

			var ndiv = new Element('div');
			ndiv.addClassName('secondaryNav');

			var tdiv = new Element('div');
			tdiv.addClassName('secondaryNavContainerTop');

			ndiv.appendChild(tdiv);

			var mdiv = new Element('div');
			mdiv.addClassName('secondaryNavContainerCenter');

			var a = this.createStdAnchor(anchor.innerHTML, anchor.getAttribute('URL'));

			var sp = new Element('span');
			sp.addClassName('primaryNavWithSubs');

			a.appendChild(sp);

			Event.observe(a, 'click', function () { navigation.clickTree(this); });

			mdiv.appendChild(a);

			var ul = new Element('ul');
			ul.addClassName('secondaryMainNav');

			for (var i = 0; i < branch.length; i++) {
				if (branch[i].nodeName == "Branch") {
					attribs = tree.getAttributes(branch[i]);

					index = tindex + '-B' + j;

					ili = new Element('li');

					var currentBranchTitleProp = this.getAttribute(attribs[0]);
					var currentBranchTitle = Translator.translate(currentBranchTitleProp);


					ia = this.createStdAnchor(currentBranchTitle, this.getAttribute(attribs[1]));

					ia.setAttribute('index', index);
					ia.id = index + '-LINK';

					Event.observe(ia, 'click', function () { navigation.clickBranch(this); });

					ili.appendChild(ia);
					ul.appendChild(ili);

					l = tree.writeLeaves(index, branch[i], ia);

					if (l != null) {
						s = new Element('span');
						s.addClassName('secondaryNavWithSubs');

						ia.appendChild(s);
						ul.appendChild(l);
					}
					j++;
				}
			}

			mdiv.appendChild(ul);
			ndiv.appendChild(mdiv);

			var bdiv = new Element('div');
			bdiv.addClassName('secondaryNavContainerBottom');
			ndiv.appendChild(bdiv);

			li.appendChild(ndiv);

		}

		return li;
	},

	writeLeaves: function (bindex, nodes, anchor) {
		var attribs, index, ili, ia;
		var li = null;
		var j = 0;

		var leaf = tree.getChildNodes(nodes);
		if (leaf != null) {
			li = new Element('li');

			li.addClassName('mainNavTertiaryContainer');
			li.setStyle({ display: 'none' });

			li.id = bindex;

			var ndiv = new Element('div');
			var tdiv = new Element('div');
			tdiv.addClassName('tertiaryNavContainerTop');
			ndiv.appendChild(tdiv);

			var mdiv = new Element('div');
			mdiv.addClassName('tertiaryNavContainerCenter');

			var a = this.createStdAnchor(anchor.innerHTML, anchor.getAttribute('URL'));

			var sp = new Element('span');
			sp.addClassName('secondaryNavWithSubs');

			a.appendChild(sp);

			Event.observe(a, 'click', function () { navigation.clickBranch(this); });

			mdiv.appendChild(a);

			var ul = new Element('ul');
			ul.addClassName('tertiaryMainNav');

			for (var i = 0; i < leaf.length; i++) {
				if (leaf[i].nodeName == "Leaf") {
					attribs = tree.getAttributes(leaf[i]);

					index = bindex + '-L' + j;

					ili = new Element('li');

					var currentLeafTitleProp = this.getAttribute(attribs[0]);
					var currentLeafTitle = Translator.translate(currentLeafTitleProp);

					ia = this.createStdAnchor(currentLeafTitle, this.getAttribute(attribs[1]));

					ia.setAttribute('index', index);
					ia.id = index + '-LINK';

					s = new Element('span');
					s.addClassName('tertiaryNavBullet');

					ia.appendChild(s);

					Event.observe(ia, 'click', function () { navigation.clickLeaf(this); });

					ili.appendChild(ia);
					ul.appendChild(ili);

					j++;
				}
			}
			mdiv.appendChild(ul);
			ndiv.appendChild(mdiv);

			var bdiv = new Element('div');
			bdiv.addClassName('tertiaryNavContainerBottom');

			ndiv.appendChild(bdiv);
			li.appendChild(ndiv);
		}

		return li;
	},

	getChildNodes: function (nodes) {
		var childNodes = null;
		try {
			for (var i = 0; i < nodes.childNodes.length; i++) {
				if (nodes.childNodes[i].nodeName == "Nodes") {
					if (nodes.childNodes[i].childNodes.length > 0) {
						childNodes = nodes.childNodes[i].childNodes;
					}
				}
			}
		}
		catch (err) { }
		return childNodes;
	},

	getAttributes: function (element) {
		var attributes = element.attributes;
		if (attributes.length) {
			return attributes;
		}
	},

	getAttribute: function (attrib) {
		var rstring = '';
		if (attrib != null) {
			rstring = attrib.nodeValue
		}
		return rstring;
	}

};



var navigation = {
    id: 'navigation',
    lastTree: null,
    lastBranch: null,
    lastLeaf: null,
    speed: 0.2,
    panelURL: null,
    lastItem: null,
    isClicked: false,
    index: null,
    
    initailize: function (nodes) {
    	tree.writeTree(nodes);
    },
    
    
    directLink: function (pageurl) {
    
    	$('mainNav').select('a').each(function (link) { 
    					
    						if (link.getAttribute('URL') == pageurl) {
    							
    							var tmpStr = link.id.substring(0, link.id.length - '-LINK'.length);
    							
    							var index = tmpStr.split('-');
								if (index != null) {
									switch (index.length) {
										case 1:
											navigation.clickTree($(tmpStr + '-LINK'), false);
											break;
										case 2:
											navigation.clickTree($(index[0] + '-LINK'), true);
											navigation.clickBranch($(tmpStr + '-LINK'), false);
											break;
										case 3:
											navigation.clickTree($(index[0] + '-LINK'), true);
											navigation.clickBranch($(index[0] + '-' + index[1] + '-LINK'), true);
											navigation.clickLeaf($(tmpStr + '-LINK'), false);
											break;
										default:
											break;
									}
								}
    							
    						}
    					
    					});
    					
    },
    
	openTree: function (tree) {
        navigation.lastTree = navigation.slideItem(tree);
        navigation.lastTree.down('a').addClassName('onMainNav');
        this.index = navigation.lastTree.id;
    },
    
    openBranch: function (branch) {
        navigation.lastBranch = navigation.slideItem(branch);
        navigation.lastBranch.down('a').addClassName('onSecondaryNav');
        this.index = navigation.lastBranch.id;
    },
    
    openLeaf: function (leaf) {
        navigation.lastLeaf = leaf.addClassName('onTertiaryNav');
    },
    
    slideItem: function (item) {
        $(item).previous().hide();
        return $(item).slideDown({ duration: navigation.speed });
    },
    
    closeLast: function (item) {
        if (item != null && item.nodeName == 'LI') {
            $(item).hide().previous().show();
        }
    },
    
    clickTree: function (item, nohistory) {
        try {
            this.resetTree(item);
            this.resetBranch(item);
            this.resetLeaf();
            var index = this.readIndex(item);
            if ($(index) != null) {
                navigation.openTree(index);
            } else {
                if (index != null) {
                    navigation.lastTree = $(item);
                    navigation.lastTree.addClassName('onMainNav');
                    this.index = index;
                } else {
                    navigation.lastTree.down('a').addClassName('onMainNav');
                    this.index = navigation.lastTree.id;
                }
            }
            this.panelURL = item.getAttribute('URL');
            this.getContent(item, nohistory);
        }
        catch (ex) {
            navigation.clickFirst();
        }
        return false;
    },
    
    clickBranch: function (item, nohistory) {
        try {
            if (navigation.lastTree != null) {
                navigation.lastTree.down('a').removeClassName('onMainNav');
            }
            this.resetBranch(item);
            this.resetLeaf();
            var index = this.readIndex(item);
            if ($(index) != null) {
                navigation.openBranch(index);
            } else {
                if (index != null) {
                    navigation.lastBranch = $(item);
                    navigation.lastBranch.addClassName('onSecondaryNav');
                    this.index = index;
                } else {
                    navigation.lastBranch.down('a').addClassName('onSecondaryNav');
                    this.index = navigation.lastBranch.id;
                }
            }
            this.panelURL = item.getAttribute('URL');
            this.getContent(item, nohistory);
        }
        catch (ex) {
            navigation.clickFirst();
        }
        return false;

    },
    
    clickLeaf: function (item, nohistory) {
        try {
            if (navigation.lastTree != null) {
                navigation.lastTree.down('a').removeClassName('onMainNav');
            }

            if (navigation.lastBranch != null) {
                navigation.lastBranch.down('a').removeClassName('onSecondaryNav');
            }
            this.resetLeaf();
            navigation.openLeaf(item);
            this.index = this.readIndex(item);
            this.panelURL = item.getAttribute('URL');
            this.getContent(item, nohistory);
        }
        catch (ex) {
            navigation.clickFirst();
        }
        return false;
    },
    
    resetLeaf: function () {
        var leaf = navigation.lastLeaf;
        if (leaf != null) {
            leaf.removeClassName('onTertiaryNav');
        }
    },
    
    resetBranch: function (item) {
        var branch = navigation.lastBranch;
        if (branch != null) {
            if (branch.hasClassName('mainNavTertiaryContainer')) {
                branch.down('a').removeClassName('onSecondaryNav');
                if (this.readIndex(item) != null) {
                    navigation.closeLast(branch);
                }
            } else {
                branch.removeClassName('onSecondaryNav');
            }
        }
    },
    
    resetTree: function (item) {
        var tree = navigation.lastTree;
        if (tree != null) {
            if (tree.hasClassName('mainNavSecondaryContainer')) {
                tree.down('a').removeClassName('onMainNav');
                if (this.readIndex(item) != null) {
                    navigation.closeLast(tree);
                }
            } else {
                tree.removeClassName('onMainNav');
            }
        }
    },

    readIndex: function (item) {
        if ($(item)) {
       		return $(item).readAttribute('index');
       	}
    },
    
    getContent: function (el, nohistory) {
        if (el != null) {
            if (el != this.lastItem) {
                var index = navigation.index;
                if (index != null) {
                    this.makeRequests(this.panelURL);
                    if (!nohistory) {
                        History.set('navigation', index);
                    }
                }
                this.lastItem = el;
            }
        }
    },
    
    makeRequests: function (item) {
        if (item != null) {
            var panel = new Ajax.Updater('mainContent', item, {
                method: 'get',
                onSuccess: this.updatePanel,
                onFailure: this.reportError,
                evalScripts: true
            });
        }
    },
    
    updatePanel: function (request) {
        postPageLoadUpdate();
    },
    
    reportError: function (request) {
        $('mainContent').innerHTML = "Error";
    },
    
    clickFirst: function () {
        if (tree.firstNode != "") {
            var item = $(tree.firstNode);
            if (item != null && !this.isClicked) {
                if (History.__currentHash == "") {
                    navigation.clickTree(item);
                } else {
                    navigation.onStateChange(History.hash.get('navigation'));
                }
            }
        }
    },
    
    onStateChange: function (newLocation) {
        if (newLocation == "") {
            navigation.clickFirst();
        } else {
            newLocation = newLocation.toUpperCase();
            var index = newLocation.split('-');
            if (index != null) {
                switch (index.length) {
                    case 1:
                        navigation.clickTree($(newLocation + '-LINK'), true);
                        break;
                    case 2:
                        navigation.clickTree($(index[0] + '-LINK'), true);
                        navigation.clickBranch($(newLocation + '-LINK'), true);
                        break;
                    case 3:
                        navigation.clickTree($(index[0] + '-LINK'), true);
                        navigation.clickBranch($(index[0] + '-' + index[1] + '-LINK'), true);
                        navigation.clickLeaf($(newLocation + '-LINK'), true);
                        break;
                    default:
                        break;
                }
            }
        }
        navigation.isClicked = true;
    },
    
    stopBubble: function (e) {
        try {
            if (!e) e = window.event;
            e.cancelBubble = true;
            if (e.stopPropagation) e.stopPropagation();
        }
        catch (e) { }
    }
};


var navigationConfigLoader = {
    
    file: '../config/menu.xml',
    initialize: function () {
        var file = window.navigationconfigfile || this.file;
        checkSession("","");
        var config = new Ajax.Request(file, { method: 'get', onSuccess: this.readConfig, onFailure: this.configError });
    },
    
    readConfig: function (request) {
        try {
            var response = request.responseXML;
            var config = response.childNodes;
            for (var i = 0; i < config.length; i++) {
                if (config[i].nodeName == "Nodes") {
                    navigation.initailize(config[i].childNodes);
                }
            }
        }
        catch (err) {
            this.configError('Error');
        }
    },
    
    configError: function (request) {
        if (request != 'Error') {
            alert('Erroring reading configuration');
        } else {
            alert('Configuration file is empty or invalid');
        }
    }
};