﻿var LoginInfo = Class.create({
    initialize: function (loginname, password) {
        this.UserName = loginname;
        this.Password = password;
    }
});

var LoginResponse = Class.create({
    initialize: function () {
        this.responseCode = '';
        this.responseTitle = '';
        this.responseMessage = '';
        this.URL='';
        this.secretKey='';
    }
});

var postLogin = {
    timer: null,
    posted: null,
    post: function () {
        var login = new LoginInfo($('userName').value, $('j_password').value);
        //turn on verify
        $('loginContainer').addClassName('loginVerify');
        //post the form
        new Ajax.Request(urlConfig.loginPost, {
            method: urlConfig.postMethod,
            parameters: login,
            onSuccess: function (transport) { postLogin.success(transport.responseText) }
        });
        postLogin.posted = true;
        return false;
    },
    success: function (obj) {
	//check if post was cancelled
        if (postLogin.posted == true) {
            postLogin.posted == false;
            //check responseCode and send to url if 0
            var loginResponse = obj.evalJSON(true).LoginResponse;
            if (loginResponse.responseCode == 0) {

                //@CSRF handler
                if( !$.sessionizer.isAvailable() ){
                    var _elm = $('fldSecretKey');
                    if(_elm.addBehavior){
                        _elm.load("secretkeypersist");
                        _elm.setAttribute("secretkeyattribute", loginResponse.secretKey );
                        _elm.save("secretkeypersist");
                    }
                }else{
                    $.sessionizer.set('secretKey',loginResponse.secretKey);
                }
                
            	//Create a form on the fly and submit to j_spring_security_check.
            	var form = document.createElement("form"); 
            	form.setAttribute("method","post"); 
            	form.setAttribute("action","j_spring_security_check"); 
            	var hiddenField = document.createElement("input"); 
            	hiddenField.setAttribute("type", "hidden"); 
            	hiddenField.setAttribute("name", "j_password"); 
            	hiddenField.setAttribute("id", "j_password");
            	hiddenField.setAttribute("value", $('j_password').value); 
            	form.appendChild(hiddenField); 
            	document.body.appendChild(form);    // Not entirely sure if this is necessary 

            	form.submit();
            } else {
                postLogin.failed(loginResponse);
            }
        }
    },
    failed: function (obj) {
	//fill in error title and message with response
        $('loginErrorTitle').innerHTML = obj.responseTitle;
        $('loginErrorMessage').innerHTML = obj.responseMessage;
        //turn off verify
        $('loginContainer').removeClassName('loginVerify');
        //turn on failed
        $('loginContainer').addClassName('loginError');
        //Clear the password after failed login
        $('j_password').value='';
        //add timer for calling tryagain after 15 seconds or so
        postLogin.timer = postLogin.tryAgain.delay(15);
   	 

    },
    tryAgain: function () {
    	$('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
         
         return false;
    },
    cancel: function () {
        //clear fields
        $('loginContainer').removeClassName('loginVerify');
        $('loginContainer').removeClassName('loginError');
        clearTimeout(postLogin.timer);
        postLogin.posted = false;
	 
    }
};
var postLogout = {
    post: function () {
        new Ajax.Request(urlConfig.logoutPost, {
            method: urlConfig.postMethod,
            onSuccess: function (transport) { postLogout.success(transport.responseText) }
        });
        return false;
    },
    success: function (obj) {
        var LogoutResponse = obj.evalJSON(true);
        if (LogoutResponse.responseCode == 0) {
            document.location.href = LogoutResponse.URL;
        } else {
            postLogout.failed(LogoutResponse);
        }
    },
    failed: function (obj) {
        //not sure what to do if this fails
    }
};