﻿//var pages = new Array();
var duration = { duration: 0.25 };
var tree = {
  firstNode: null,
  writeTree: function(nodes) {
    var attribs, index, buttoncss;
    var navbuttons = $('nav_content');
    var j = 0;
    for (var i = 0; i < nodes.length; i++) {
      if (nodes[i].nodeName == "Tree") {
        attribs = this.getAttributes(nodes[i]);
        index = 'T' + j;
        var el = document.createElement('div');
        el = this.writeAttributes(el, this.getAttribute(attribs[1]), index, this.getAttribute(attribs[0]), 'Tree', this.getAttribute(attribs[2]));
        if (j == 0) {
          this.firstNode = el.id;
        }
        buttoncss = this.getAttribute(attribs[3]);
        el.className = 'nav_button ' + buttoncss;
        navbuttons.appendChild(el);
        tree.writeBranches(index, nodes[i]);
        j++;
      }
    }
  },
  writeBranches: function(tindex, nodes) {
    var el, base, attribs, index;
    var navcontent = $('nav_content');
    var j = 0;
    var branch = tree.getChildNodes(nodes);
    if (branch != null) {
      base = document.createElement('div');
      base.id = tindex;
      base.className = 'tree_contents';
      base.style.display = 'none';
      var classname;
      for (var i = 0; i < branch.length; i++) {
        if (branch[i].nodeName == "Branch") {
          attribs = tree.getAttributes(branch[i]);
          el = document.createElement('div');
          classname = 'subnav_button';
          index = tindex + '-B' + j;
          el = this.writeAttributes(el, this.getAttribute(attribs[1]), index, this.getAttribute(attribs[0]), 'Branch', this.getAttribute(attribs[2]));
          base.appendChild(el);
          var l = tree.writeLeaves(index, branch[i]);
          if (l != null) {
            base.appendChild(l);
            classname += ' open_branch';
          }
          el.className = classname;
          j++;
        }
      }
      navcontent.appendChild(base);
    }
  },
  writeLeaves: function(bindex, nodes) {
    var leafel, attribs, index;
    var el = null;
    var innerel = null;
    var j = 0;
    var leaf = tree.getChildNodes(nodes);
    if (leaf != null) {
      el = document.createElement('div');
      el.className = "subnav_contents";
      el.id = bindex;
      el.style.display = 'none';
      innerel = document.createElement('div');
      innerel.className = "lower_subnav_button";
      el.appendChild(innerel);
      for (var i = 0; i < leaf.length; i++) {
        if (leaf[i].nodeName == "Leaf") {
          attribs = tree.getAttributes(leaf[i]);
          leafel = document.createElement('div');
          index = bindex + '-L' + j;
          leafel = this.writeAttributes(leafel, this.getAttribute(attribs[1]), index, this.getAttribute(attribs[0]), 'Leaf', this.getAttribute(attribs[2]));
          leafel.className = "lower_subnav";
          innerel.appendChild(leafel);
          j++;
        }
      }
    }
    return el;
  },
  writeAttributes: function(el, url, index, innerhtml, type, popup) {
    el.innerHTML = innerhtml;
    el.id = index + '-DIV';
    el.setAttribute('URL', url);
    el.setAttribute('Type', type);
    el.setAttribute('index', index);
    el.setAttribute('Popup', popup);
    Event.observe(el, 'mouseover', function() { this.addClassName('nav_mouseover') });
    Event.observe(el, 'mouseout', function() { this.removeClassName('nav_mouseover') });
    Event.observe(el, 'click', function() { navigation.click(this) });
    return el;
  },
  getChildNodes: function(nodes) {
    var childNodes = null;
    try {
      for (var i = 0; i < nodes.childNodes.length; i++) {
        if (nodes.childNodes[i].nodeName == "Nodes") {
          if (nodes.childNodes[i].childNodes.length > 0) {
            childNodes = nodes.childNodes[i].childNodes;
          }
        }
      }
    }
    catch (err) { }
    return childNodes;
  },
  getAttributes: function(element) {
    var attributes = element.attributes;
    if (attributes.length) {
      return attributes;
    }
  },
  getAttribute: function(attrib) {
    var rstring = '';
    if (attrib != null) {
      rstring = attrib.nodeValue
    }
    return rstring;
  }

};
var navigation = {
  id: 'navigation',
  isClicked: false,
  lastTree: null,
  lastBranch: null,
  lastLeaf: null,
  lastItem: null,
  panelURL: null,
  initailize: function(nodes) {
    Event.observe(window, 'resize', function() { navigation.resize() });
    tree.writeTree(nodes);
  },
  resetLastLeaf: function() {
    if (this.lastLeaf != null) {
      this.lastLeaf.removeClassName('lower_subnav_selected');
    }
  },
  resetLastBranch: function(hide) {
    if (this.lastBranch != null) {
      this.lastBranch.removeClassName('subnav_button_selected');
      var leaf = $(this.lastBranch.getAttribute('index'));
      if (leaf != null) {
        this.lastBranch.addClassName('open_branch');
        this.lastBranch.removeClassName('close_branch');
        if (hide) {
          if (leaf != null) {
            leaf.style.display = 'none';
          }
        }
      }
    }
  },
  resetLastTree: function(hide) {
    if (this.lastTree != null) {
      this.lastTree.removeClassName('nav_select');
      if (hide) {
        var branch = $(this.lastTree.getAttribute('index'));
        if (branch != null) {
          branch.style.display = 'none';
        }
      }
    }
  },
  resetAll: function() {
    this.resetLastTree(true);
    this.resetLastBranch(true);
    this.resetLastLeaf();
  },
  setTree: function(el, noslide) {
    if (el != null) {

      var bc = document.createElement('span');
      //bc.appendChild(breadCrumbs.makeLink(el));
      el.addClassName('nav_select');

      var item = $(el.getAttribute('index'));
      if (item != null) {
        noslide ? item.style.display = 'block' : Effect.toggle(item, 'slide', duration);
      }
      this.lastTree = el;
      this.panelURL = el.getAttribute('URL');
    }
  },
  setBranch: function(el, noslide) {
    if (el != null) {
      el.addClassName('subnav_button_selected');

      leaf = $(el.getAttribute('index'));
      if (leaf != null) {
        noslide ? leaf.style.display = 'block' : Effect.toggle(leaf, 'slide', duration);
        el.addClassName('close_branch');
        el.removeClassName('open_branch');
      }
      this.lastBranch = el;
      this.panelURL = el.getAttribute('URL');
    }
  },
  setLeaf: function(el) {
    if (el != null) {
      el.addClassName('lower_subnav_selected');
      this.lastLeaf = el;
      this.panelURL = el.getAttribute('URL');
    }
  },
  compareIndex: function(el1, el2) {
    var rbool = false;
    try {
      if (el1 != null && el1.getAttribute('index') == el2.getAttribute('index')) {
        rbool = true;
      }
    }
    catch (e) { };
    return rbool;
  },
  hideBranches: function() {
    var leaf;
    var index = $(this.lastTree.getAttribute('index'));
    if (index != null) {
      //get the childnodes
      var children = index.childNodes;
      //go through each child node that does not end in DIV and hide them
      for (var i = 0; i < children.length; i++) {
        if (children[i].className.search(/\bclose_branch\b/) != -1) {
          children[i].addClassName('open_branch');
          children[i].removeClassName('close_branch');
          leaf = $(children[i].getAttribute('index'));
          leaf.style.display = 'none';
        }
      }
    }
  },
  click: function(el) {
    var type = el.getAttribute('Type');
    if (type == 'Tree') {
      if (this.lastTree == null) {
        this.setTree(el);
      } else {
        if (el == this.lastTree) {
          this.resetLastBranch();
          this.resetLastLeaf();
        } else {
          this.hideBranches();
          this.resetLastTree(true);
          this.resetLastBranch();
          this.resetLastLeaf();
          this.setTree(el);
        }
      }
      //this.setTree(el);
    }
    if (type == 'Branch') {
      if (this.lastBranch == null) {
        this.setBranch(el);
      } else {
        if (this.compareIndex(this.lastBranch, el)) {
          this.resetLastLeaf();
        } else {
          this.resetLastBranch(true);
          this.resetLastLeaf();
          this.setBranch(el);
        }
      }
      //this.setBranch(el);
    }
    if (type == 'Leaf') {
      this.resetLastLeaf();
      var level = el.getAttribute('index').split('-');
      var item = $(level[0] + '-' + level[1] + '-DIV');
      if (item != null && !this.compareIndex(this.lastBranch, item)) {
        this.resetLastBranch();
        item.addClassName('subnav_button_selected');
        this.lastBranch = item;
      }
      this.setLeaf(el);
    }
    this.getContent(el);
  },
  resize: function() {
    try {
      var nic = $('nav').getHeight();
      $('nav_content').setStyle({ height: nic + 'px' });
    }
    catch (err) { }
  },
  getContent: function(el, nohistory) {
    if (el != null) {
      var popup = el.getAttribute('Popup');
      if (popup == 'true') {
        popUp.openWindow(this.panelURL);
      }
      else {
        if (el != this.lastItem) {
          var index = el.getAttribute('index');
          if (index != null) {
            this.makeRequests(this.panelURL);
            if (!nohistory) {
              History.set('navigation', index);
            }
          }
          //breadCrumbs.write(el);
          this.resize();
          this.lastItem = el;
        }
      }
    }

  },

  updatePanel: function(request) {
    var response = request.responseText || "No response text";
    $('main_content').innerHTML = response;
  },
  reportError: function(request) {
    $('main_content').innerHTML = "Error";
  },
  onStateChange: function(newLocation) {
    if (newLocation == "") {
      navigation.clickFirst();
    } else {
      newLocation = newLocation.toUpperCase();
      var index = newLocation.split('-');
      if (index != null) {
        switch (index.length) {
          case 1:
            navigation.resetAll();
            var tree = index[0];
            navigation.setTree($(tree + '-DIV'), true);
            navigation.getContent($(tree + '-DIV'), true);
            break;
          case 2:
            //Branch
            navigation.resetAll();
            var tree = index[0];
            var branch = tree + '-' + index[1];
            navigation.setTree($(tree + '-DIV'), true);
            navigation.setBranch($(branch + '-DIV'), true);
            navigation.getContent($(branch + '-DIV'), true);
            break;
          case 3:
            //Leaf
            navigation.resetAll();
            var tree = index[0];
            var branch = tree + '-' + index[1];
            var leaf = branch + '-' + index[2];
            navigation.setTree($(tree + '-DIV'), true);
            navigation.setBranch($(branch + '-DIV'), true);
            navigation.setLeaf($(leaf + '-DIV'));
            navigation.getContent($(leaf + '-DIV'), true);
            break;
          default:
            break;
        }
      }
    }
    navigation.isClicked = true;
  },
  clickFirst: function() {
    var item = $(tree.firstNode);
    if (item != null && !this.isClicked) {
      if (History.__currentHash == "") {
        navigation.click(item);
      } else {
        navigation.onStateChange(History.hash.get('navigation'));
      }
    }
  },
  makeRequests: function(item) {
    if (item != null) {
      var panel = new Ajax.Request(item, { method: 'get', onSuccess: this.updatePanel, onFailure: this.reportError });
    }
  }
}
var breadCrumbs = {
  initalize: function() {
    this.system = $('servername');
  },
  write: function(el) {
    switch (el.getAttribute('Type')) {
      case ('Tree'):
        if (el.id != tree.firstNode) {
          this.combine(this.system, navigation.lastTree);
        } else {
          this.combine(this.system);
          //this.combine('');
        }
        break;
      case ('Branch'):
        this.branch = el;
        this.combine(this.system, navigation.lastTree, navigation.lastBranch);
        break;
      case ('Leaf'):
        this.leaf = el;
        this.combine(this.system, navigation.lastTree, navigation.lastBranch, navigation.lastLeaf);
        break;
      default:
        break;
    }
  },
  combine: function(s, t, b, l) {
    var bc = document.createElement('span');
    if (s != '') {
      bc.appendChild(this.makeLink(s));
    }
    for (var i = 1; i < arguments.length; i++) {
      bc.appendChild(document.createTextNode(' : '));
      bc.appendChild(this.makeLink(arguments[i]));
    }
    $('breadcrumb').innerHTML = bc.innerHTML;
  },
  makeLink: function(el) {
    var item = document.createElement('a');
    if (el != null) {
      item.setAttribute('href', 'javascript:breadCrumbs.click(\'' + el.id + '\')');
      item.appendChild(document.createTextNode(el.innerHTML));
    }
    return item;
  },
  click: function(link) {
    var l;
    if (link == 'servername') {
      l = $(tree.firstNode);
    } else {
      l = $(link);
    }
    navigation.click(l);
  }
}
var page = {
  mNavWidth: null,
  navWidth: function() {
    return Element.getWidth('nav');
  },
  initailize: function() {
    Event.observe(window, 'resize', function() { page.resize() });
    Event.observe('nav_strip', 'mousedown', function(event) { pullTab.ra_resizeStart(event, Event.element(event)) });
    Event.observe('nav_strip', 'dblclick', function(event) { page.collapseNav() });
    this.resize();
  },
  resize: function() {
    var dim = this.getDimensions();
    var header = Element.getHeight('masthead');
    $('content').setStyle({ height: dim.height - header + 'px' });
    //var breadcrumb = Element.getHeight('breadcrumb');
    //$('main_content').setStyle({ height: dim.height - header - breadcrumb + 'px' });
    $('main_content').setStyle({ height: dim.height - header + 'px' });
    this.setWidth();
  },
  getDimensions: function() {
    var dim = document.viewport.getDimensions();
    return dim;
  },
  setWidth: function(width) {
    var dim = this.getDimensions();
    var nav;
    if (!width) {
      nav = this.navWidth();
    } else {
      $('nav').setStyle({ width: width + 'px' });
      $('nav_strip').setStyle({ left: width + 'px' });
      nav = width;
    }
    var cen = Element.getWidth('nav_strip');
    $('main').setStyle({ width: dim.width - nav - cen + 'px', left: nav + cen + 'px' });
    $('main_content').setStyle({ width: dim.width - nav - cen + 'px', overflow: 'auto' });
  },
  collapseNav: function() {
    var mwidth = parseInt(Element.getStyle('nav', 'min-width'));
    this.setWidth(mwidth);
  },

  checkNav: function(width) {
    var mwidth = parseInt(Element.getStyle('nav', 'min-width'));
    if (width > mwidth) {
      this.setWidth(width);
    }
    if (width < mwidth) {
      this.setWidth(mwidth);
    }

  }
}
var pullTab = {
  ra_resizeStart: function(e, splitter) {
    this.dragging = true;
    this.rightSectionMinWidth = 200;
    this.ra_splitter = splitter;
    splitter.parrentOffsetX = pullTab.ra_GetX(splitter.parentNode) + e.clientX - pullTab.ra_GetX(splitter);
    document.onmousemove = function(e) { if (!e) { e = window.event; } pullTab.ra_mouseMove(e); };
    document.onmouseup = function(e) { if (!e) { e = window.event; } pullTab.ra_resizeStop(e); };
    document.body.ondrag = function() { return !pullTab.dragging; };
    return false;
  },
  ra_GetX: function(oElement) {
    var x = 0;
    while (oElement != null) {
      x += oElement.offsetLeft;
      oElement = oElement.offsetParent;
    }
    return x;
  },
  ra_mouseMove: function(e) {
    var splitter = this.ra_splitter;
    x = e.clientX - splitter.parrentOffsetX;
    if (x >= splitter.parentNode.offsetWidth - splitter.offsetWidth - pullTab.rightSectionMinWidth) {
      x = splitter.parentNode.offsetWidth - splitter.offsetWidth - pullTab.rightSectionMinWidth;
    }
    splitter.style.left = x + "px";
    return false;
  },
  ra_resizeStop: function() {
    document.onmousemove = null;
    document.onmouseup = null;
    var splitter = this.ra_splitter;
    page.checkNav(splitter.offsetLeft);
    pullTab.dragging = false;
    //clear the document selection
    if (document.selection) { document.selection.empty(); }
    else if (window.getSelection)
    { window.getSelection().removeAllRanges(); }
  }
};
var configuration = {
    file: 'index.xml',
    initialize: function () {
        var file = window.configurationfile || this.file;
        var config = new Ajax.Request(this.file, { method: 'get', onSuccess: this.readConfig, onFailure: this.configError });
    },
    readConfig: function (request) {
        try {
            var response = request.responseXML;
            var config = response.childNodes;
            for (var i = 0; i < config.length; i++) {
                if (config[i].nodeName == "Nodes") {
                    navigation.initailize(config[i].childNodes);
                }
            }
        }
        catch (err) {
            this.configError('Error');
        }
    },
    configError: function (request) {
        if (request != 'Error') {
            alert('Erroring reading configuration');
        } else {
            alert('Configuration file is empty or invalid');
        }
    }
};
var popUp = {
  initialize: function() {
  popUp.setHeight();
  Event.observe(window, "scroll", function() { popUp.setHeight(); });
  Event.observe(window, "resize", function() { popUp.setHeight(); });
  },
  setHeight: function() {
    var viewheight = document.viewport.getHeight();
    var popupoverflow = $('popup_overflow');
    if (popupoverflow) {
      var offset = popUp.findPos(popupoverflow)[1];
      popupoverflow.setStyle({height : viewheight - offset + 'px'});
    }
  },
  findPos: function(obj) {
    var curleft = curtop = 0;
    if (obj.offsetParent) {
      do {
        curleft += obj.offsetLeft;
        curtop += obj.offsetTop;
      } while (obj = obj.offsetParent);
      return [curleft, curtop];
    }
  },
  openWindow: function(url, windowtitle, popwidth, popheight) {
    if (windowtitle == null) {
      var windowtitle = 'popup';
    }
    if (popwidth == null) {
      popwidth = 1024;
    }
    if (popheight == null) {
      popheight = 768;
    }
    if (url != null) {
      window.open(url, windowtitle, 'width=' + popwidth + ',height=' + popheight + ',toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,copyhistory=no,resizable=yes');
    }
  },
  closeWindow: function() {
    window.close();
  },
  scrolltoTop: function() {
    var popupoverflow = $('popup_overflow');
    if (popupoverflow) { popupoverflow.scrollTop = 0; }
  }
};
if (typeof document.observe == 'function') {
  document.observe("dom:loaded", function() {
    configuration.initialize();
    History.Observer.start();
    History.Observer.delay = 0.5;
    History.Registry.set(navigation, function(value) { navigation.onStateChange(value) });
  });
  Event.observe(window, 'load', function() {
    setTimeout(function() {
      //breadCrumbs.initalize();
      page.initailize();
      navigation.clickFirst();
    }, 300);

  });
};

        